' Copyright (c) 2008  Future Technology Devices International Ltd.
'
' Module Name
'
'     MainForm.vb
'
' Abstract:
'
'    Visual Basic program, to test the FTCSPI.DLL. The FTCSPI.DLL is used to control the FT2232H dual hi-speed device
'    and the FT4232H quad hi-speed device to simulate the Serial Peripheral Interface(SPI) synchronous serial protocol
'    to communicate with SPI devices connected to FT2232H dual hi-speed devices and FT4232H quad hi-speed devices.
'
' Revision History:
'
'   23/08/08    Kirke Ashton    Created.
'
Public Class MainForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Friend WithEvents DLLVersionLabel As System.Windows.Forms.Label
    Friend WithEvents GPIOH0InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH0OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH0WriteUseNotUseStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH0OutputLowHighWriteStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH1InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH1OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH2InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH2OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH3InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH3OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH1WriteUseNotUseStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH1OutputLowHighWriteStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH2WriteUseNotUseStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH2OutputLowHighWriteStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH3WriteUseNotUseStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH3OutputLowHighWriteStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH0To7OnlyCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH0ReadUseNotUseStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH1ReadUseNotUseStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH2ReadUseNotUseStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH3ReadUseNotUseStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH0InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH1InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH2InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH3InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents ChannelLabel As System.Windows.Forms.Label
    Friend WithEvents ChannelComboBox As System.Windows.Forms.ComboBox
    Friend WithEvents DeviceNameLabel As System.Windows.Forms.Label
    Friend WithEvents HiSpeedDeviceTypeGroupBox As System.Windows.Forms.GroupBox
    Friend WithEvents FT2232HRadioButton As System.Windows.Forms.RadioButton
    Friend WithEvents FT4232HRadioButton As System.Windows.Forms.RadioButton
    Friend WithEvents MainMenuStrip As System.Windows.Forms.MenuStrip
    Friend WithEvents OptionsMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents CommandSequenceMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents ToolStripSeparator1 As System.Windows.Forms.ToolStripSeparator
    Friend WithEvents ExitMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents PassFailureStatusStrip As System.Windows.Forms.StatusStrip
    Friend WithEvents PassFailStatusLabel As System.Windows.Forms.ToolStripStatusLabel
    Friend WithEvents PassFailResultsStatusLabel As System.Windows.Forms.ToolStripStatusLabel
    Friend WithEvents GPIOH4InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH4OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH5InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH5OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH6InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH6OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH7InputOutputInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH7OutputLowHighInitialStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH4WriteUseNotUseStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH4OutputLowHighWriteStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH5WriteUseNotUseStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH5OutputLowHighWriteStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH6WriteUseNotUseStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH6OutputLowHighWriteStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH7WriteUseNotUseStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH7OutputLowHighWriteStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH4ReadUseNotUseStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH4InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH5ReadUseNotUseStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH5InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH6ReadUseNotUseStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH6InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH7ReadUseNotUseStateCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GPIOH7InputLowHighReadStateCheckBox As System.Windows.Forms.CheckBox

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents TestButton As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(MainForm))
        Me.TestButton = New System.Windows.Forms.Button
        Me.DLLVersionLabel = New System.Windows.Forms.Label
        Me.GPIOH0InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH0OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH0WriteUseNotUseStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH0OutputLowHighWriteStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH1InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH1OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH2InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH2OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH3InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH3OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH1WriteUseNotUseStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH1OutputLowHighWriteStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH2WriteUseNotUseStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH2OutputLowHighWriteStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH3WriteUseNotUseStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH3OutputLowHighWriteStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH0To7OnlyCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH0ReadUseNotUseStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH1ReadUseNotUseStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH2ReadUseNotUseStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH3ReadUseNotUseStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH0InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH1InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH2InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH3InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.ChannelLabel = New System.Windows.Forms.Label
        Me.ChannelComboBox = New System.Windows.Forms.ComboBox
        Me.DeviceNameLabel = New System.Windows.Forms.Label
        Me.HiSpeedDeviceTypeGroupBox = New System.Windows.Forms.GroupBox
        Me.FT4232HRadioButton = New System.Windows.Forms.RadioButton
        Me.FT2232HRadioButton = New System.Windows.Forms.RadioButton
        Me.MainMenuStrip = New System.Windows.Forms.MenuStrip
        Me.OptionsMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.CommandSequenceMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.ToolStripSeparator1 = New System.Windows.Forms.ToolStripSeparator
        Me.ExitMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.PassFailureStatusStrip = New System.Windows.Forms.StatusStrip
        Me.PassFailStatusLabel = New System.Windows.Forms.ToolStripStatusLabel
        Me.PassFailResultsStatusLabel = New System.Windows.Forms.ToolStripStatusLabel
        Me.GPIOH4InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH4OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH5InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH5OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH6InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH6OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH7InputOutputInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH7OutputLowHighInitialStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH4WriteUseNotUseStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH4OutputLowHighWriteStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH5WriteUseNotUseStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH5OutputLowHighWriteStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH6WriteUseNotUseStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH6OutputLowHighWriteStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH7WriteUseNotUseStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH7OutputLowHighWriteStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH4ReadUseNotUseStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH4InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH5ReadUseNotUseStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH5InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH6ReadUseNotUseStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH6InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH7ReadUseNotUseStateCheckBox = New System.Windows.Forms.CheckBox
        Me.GPIOH7InputLowHighReadStateCheckBox = New System.Windows.Forms.CheckBox
        Me.HiSpeedDeviceTypeGroupBox.SuspendLayout()
        Me.MainMenuStrip.SuspendLayout()
        Me.PassFailureStatusStrip.SuspendLayout()
        Me.SuspendLayout()
        '
        'TestButton
        '
        Me.TestButton.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.TestButton.Location = New System.Drawing.Point(769, 546)
        Me.TestButton.Name = "TestButton"
        Me.TestButton.Size = New System.Drawing.Size(72, 24)
        Me.TestButton.TabIndex = 0
        Me.TestButton.Text = "Test"
        '
        'DLLVersionLabel
        '
        Me.DLLVersionLabel.AutoSize = True
        Me.DLLVersionLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.DLLVersionLabel.Location = New System.Drawing.Point(26, 96)
        Me.DLLVersionLabel.Name = "DLLVersionLabel"
        Me.DLLVersionLabel.Size = New System.Drawing.Size(211, 13)
        Me.DLLVersionLabel.TabIndex = 1
        Me.DLLVersionLabel.Text = "FT2232/FT4232 SPI DLL Version = "
        '
        'GPIOH0InputOutputInitialStateCheckBox
        '
        Me.GPIOH0InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOH0InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOH0InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOH0InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(287, 44)
        Me.GPIOH0InputOutputInitialStateCheckBox.Name = "GPIOH0InputOutputInitialStateCheckBox"
        Me.GPIOH0InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(232, 17)
        Me.GPIOH0InputOutputInitialStateCheckBox.TabIndex = 3
        Me.GPIOH0InputOutputInitialStateCheckBox.Text = "GPIOH0 Input Output(Checked) Initial State"
        Me.GPIOH0InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH0OutputLowHighInitialStateCheckBox
        '
        Me.GPIOH0OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOH0OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(297, 58)
        Me.GPIOH0OutputLowHighInitialStateCheckBox.Name = "GPIOH0OutputLowHighInitialStateCheckBox"
        Me.GPIOH0OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(253, 17)
        Me.GPIOH0OutputLowHighInitialStateCheckBox.TabIndex = 4
        Me.GPIOH0OutputLowHighInitialStateCheckBox.Text = "GPIOH0 Output Low High(Checked) Initial State"
        Me.GPIOH0OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH0WriteUseNotUseStateCheckBox
        '
        Me.GPIOH0WriteUseNotUseStateCheckBox.AutoSize = True
        Me.GPIOH0WriteUseNotUseStateCheckBox.Location = New System.Drawing.Point(577, 43)
        Me.GPIOH0WriteUseNotUseStateCheckBox.Name = "GPIOH0WriteUseNotUseStateCheckBox"
        Me.GPIOH0WriteUseNotUseStateCheckBox.Size = New System.Drawing.Size(235, 17)
        Me.GPIOH0WriteUseNotUseStateCheckBox.TabIndex = 5
        Me.GPIOH0WriteUseNotUseStateCheckBox.Text = "GPIOH0 Use(Checked) Not Use Write State"
        Me.GPIOH0WriteUseNotUseStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH0OutputLowHighWriteStateCheckBox
        '
        Me.GPIOH0OutputLowHighWriteStateCheckBox.AutoSize = True
        Me.GPIOH0OutputLowHighWriteStateCheckBox.Enabled = False
        Me.GPIOH0OutputLowHighWriteStateCheckBox.Location = New System.Drawing.Point(587, 58)
        Me.GPIOH0OutputLowHighWriteStateCheckBox.Name = "GPIOH0OutputLowHighWriteStateCheckBox"
        Me.GPIOH0OutputLowHighWriteStateCheckBox.Size = New System.Drawing.Size(254, 17)
        Me.GPIOH0OutputLowHighWriteStateCheckBox.TabIndex = 6
        Me.GPIOH0OutputLowHighWriteStateCheckBox.Text = "GPIOH0 Output Low High(Checked) Write State"
        Me.GPIOH0OutputLowHighWriteStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH1InputOutputInitialStateCheckBox
        '
        Me.GPIOH1InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOH1InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOH1InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOH1InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(287, 81)
        Me.GPIOH1InputOutputInitialStateCheckBox.Name = "GPIOH1InputOutputInitialStateCheckBox"
        Me.GPIOH1InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(232, 17)
        Me.GPIOH1InputOutputInitialStateCheckBox.TabIndex = 7
        Me.GPIOH1InputOutputInitialStateCheckBox.Text = "GPIOH1 Input Output(Checked) Initial State"
        Me.GPIOH1InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH1OutputLowHighInitialStateCheckBox
        '
        Me.GPIOH1OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOH1OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(297, 97)
        Me.GPIOH1OutputLowHighInitialStateCheckBox.Name = "GPIOH1OutputLowHighInitialStateCheckBox"
        Me.GPIOH1OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(253, 17)
        Me.GPIOH1OutputLowHighInitialStateCheckBox.TabIndex = 8
        Me.GPIOH1OutputLowHighInitialStateCheckBox.Text = "GPIOH1 Output Low High(Checked) Initial State"
        Me.GPIOH1OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH2InputOutputInitialStateCheckBox
        '
        Me.GPIOH2InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOH2InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOH2InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOH2InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(287, 120)
        Me.GPIOH2InputOutputInitialStateCheckBox.Name = "GPIOH2InputOutputInitialStateCheckBox"
        Me.GPIOH2InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(232, 17)
        Me.GPIOH2InputOutputInitialStateCheckBox.TabIndex = 9
        Me.GPIOH2InputOutputInitialStateCheckBox.Text = "GPIOH2 Input Output(Checked) Initial State"
        Me.GPIOH2InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH2OutputLowHighInitialStateCheckBox
        '
        Me.GPIOH2OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOH2OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(297, 135)
        Me.GPIOH2OutputLowHighInitialStateCheckBox.Name = "GPIOH2OutputLowHighInitialStateCheckBox"
        Me.GPIOH2OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(253, 17)
        Me.GPIOH2OutputLowHighInitialStateCheckBox.TabIndex = 10
        Me.GPIOH2OutputLowHighInitialStateCheckBox.Text = "GPIOH2 Output Low High(Checked) Initial State"
        Me.GPIOH2OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH3InputOutputInitialStateCheckBox
        '
        Me.GPIOH3InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOH3InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOH3InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOH3InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(287, 158)
        Me.GPIOH3InputOutputInitialStateCheckBox.Name = "GPIOH3InputOutputInitialStateCheckBox"
        Me.GPIOH3InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(232, 17)
        Me.GPIOH3InputOutputInitialStateCheckBox.TabIndex = 11
        Me.GPIOH3InputOutputInitialStateCheckBox.Text = "GPIOH3 Input Output(Checked) Initial State"
        Me.GPIOH3InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH3OutputLowHighInitialStateCheckBox
        '
        Me.GPIOH3OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOH3OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(297, 176)
        Me.GPIOH3OutputLowHighInitialStateCheckBox.Name = "GPIOH3OutputLowHighInitialStateCheckBox"
        Me.GPIOH3OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(253, 17)
        Me.GPIOH3OutputLowHighInitialStateCheckBox.TabIndex = 12
        Me.GPIOH3OutputLowHighInitialStateCheckBox.Text = "GPIOH3 Output Low High(Checked) Initial State"
        Me.GPIOH3OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH1WriteUseNotUseStateCheckBox
        '
        Me.GPIOH1WriteUseNotUseStateCheckBox.AutoSize = True
        Me.GPIOH1WriteUseNotUseStateCheckBox.Location = New System.Drawing.Point(577, 81)
        Me.GPIOH1WriteUseNotUseStateCheckBox.Name = "GPIOH1WriteUseNotUseStateCheckBox"
        Me.GPIOH1WriteUseNotUseStateCheckBox.Size = New System.Drawing.Size(235, 17)
        Me.GPIOH1WriteUseNotUseStateCheckBox.TabIndex = 13
        Me.GPIOH1WriteUseNotUseStateCheckBox.Text = "GPIOH1 Use(Checked) Not Use Write State"
        Me.GPIOH1WriteUseNotUseStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH1OutputLowHighWriteStateCheckBox
        '
        Me.GPIOH1OutputLowHighWriteStateCheckBox.AutoSize = True
        Me.GPIOH1OutputLowHighWriteStateCheckBox.Enabled = False
        Me.GPIOH1OutputLowHighWriteStateCheckBox.Location = New System.Drawing.Point(587, 95)
        Me.GPIOH1OutputLowHighWriteStateCheckBox.Name = "GPIOH1OutputLowHighWriteStateCheckBox"
        Me.GPIOH1OutputLowHighWriteStateCheckBox.Size = New System.Drawing.Size(254, 17)
        Me.GPIOH1OutputLowHighWriteStateCheckBox.TabIndex = 14
        Me.GPIOH1OutputLowHighWriteStateCheckBox.Text = "GPIOH1 Output Low High(Checked) Write State"
        Me.GPIOH1OutputLowHighWriteStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH2WriteUseNotUseStateCheckBox
        '
        Me.GPIOH2WriteUseNotUseStateCheckBox.AutoSize = True
        Me.GPIOH2WriteUseNotUseStateCheckBox.Location = New System.Drawing.Point(577, 120)
        Me.GPIOH2WriteUseNotUseStateCheckBox.Name = "GPIOH2WriteUseNotUseStateCheckBox"
        Me.GPIOH2WriteUseNotUseStateCheckBox.Size = New System.Drawing.Size(235, 17)
        Me.GPIOH2WriteUseNotUseStateCheckBox.TabIndex = 15
        Me.GPIOH2WriteUseNotUseStateCheckBox.Text = "GPIOH2 Use(Checked) Not Use Write State"
        Me.GPIOH2WriteUseNotUseStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH2OutputLowHighWriteStateCheckBox
        '
        Me.GPIOH2OutputLowHighWriteStateCheckBox.AutoSize = True
        Me.GPIOH2OutputLowHighWriteStateCheckBox.Enabled = False
        Me.GPIOH2OutputLowHighWriteStateCheckBox.Location = New System.Drawing.Point(587, 135)
        Me.GPIOH2OutputLowHighWriteStateCheckBox.Name = "GPIOH2OutputLowHighWriteStateCheckBox"
        Me.GPIOH2OutputLowHighWriteStateCheckBox.Size = New System.Drawing.Size(254, 17)
        Me.GPIOH2OutputLowHighWriteStateCheckBox.TabIndex = 16
        Me.GPIOH2OutputLowHighWriteStateCheckBox.Text = "GPIOH2 Output Low High(Checked) Write State"
        Me.GPIOH2OutputLowHighWriteStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH3WriteUseNotUseStateCheckBox
        '
        Me.GPIOH3WriteUseNotUseStateCheckBox.AutoSize = True
        Me.GPIOH3WriteUseNotUseStateCheckBox.Location = New System.Drawing.Point(577, 158)
        Me.GPIOH3WriteUseNotUseStateCheckBox.Name = "GPIOH3WriteUseNotUseStateCheckBox"
        Me.GPIOH3WriteUseNotUseStateCheckBox.Size = New System.Drawing.Size(235, 17)
        Me.GPIOH3WriteUseNotUseStateCheckBox.TabIndex = 17
        Me.GPIOH3WriteUseNotUseStateCheckBox.Text = "GPIOH3 Use(Checked) Not Use Write State"
        Me.GPIOH3WriteUseNotUseStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH3OutputLowHighWriteStateCheckBox
        '
        Me.GPIOH3OutputLowHighWriteStateCheckBox.AutoSize = True
        Me.GPIOH3OutputLowHighWriteStateCheckBox.Enabled = False
        Me.GPIOH3OutputLowHighWriteStateCheckBox.Location = New System.Drawing.Point(587, 176)
        Me.GPIOH3OutputLowHighWriteStateCheckBox.Name = "GPIOH3OutputLowHighWriteStateCheckBox"
        Me.GPIOH3OutputLowHighWriteStateCheckBox.Size = New System.Drawing.Size(254, 17)
        Me.GPIOH3OutputLowHighWriteStateCheckBox.TabIndex = 18
        Me.GPIOH3OutputLowHighWriteStateCheckBox.Text = "GPIOH3 Output Low High(Checked) Write State"
        Me.GPIOH3OutputLowHighWriteStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH0To7OnlyCheckBox
        '
        Me.GPIOH0To7OnlyCheckBox.AutoSize = True
        Me.GPIOH0To7OnlyCheckBox.Location = New System.Drawing.Point(29, 281)
        Me.GPIOH0To7OnlyCheckBox.Name = "GPIOH0To7OnlyCheckBox"
        Me.GPIOH0To7OnlyCheckBox.Size = New System.Drawing.Size(138, 17)
        Me.GPIOH0To7OnlyCheckBox.TabIndex = 19
        Me.GPIOH0To7OnlyCheckBox.Text = "Test GPIOH (0 - 7) Only"
        Me.GPIOH0To7OnlyCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH0ReadUseNotUseStateCheckBox
        '
        Me.GPIOH0ReadUseNotUseStateCheckBox.AutoSize = True
        Me.GPIOH0ReadUseNotUseStateCheckBox.Location = New System.Drawing.Point(287, 386)
        Me.GPIOH0ReadUseNotUseStateCheckBox.Name = "GPIOH0ReadUseNotUseStateCheckBox"
        Me.GPIOH0ReadUseNotUseStateCheckBox.Size = New System.Drawing.Size(236, 17)
        Me.GPIOH0ReadUseNotUseStateCheckBox.TabIndex = 20
        Me.GPIOH0ReadUseNotUseStateCheckBox.Text = "GPIOH0 Use(Checked) Not Use Read State"
        Me.GPIOH0ReadUseNotUseStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH1ReadUseNotUseStateCheckBox
        '
        Me.GPIOH1ReadUseNotUseStateCheckBox.AutoSize = True
        Me.GPIOH1ReadUseNotUseStateCheckBox.Location = New System.Drawing.Point(287, 421)
        Me.GPIOH1ReadUseNotUseStateCheckBox.Name = "GPIOH1ReadUseNotUseStateCheckBox"
        Me.GPIOH1ReadUseNotUseStateCheckBox.Size = New System.Drawing.Size(236, 17)
        Me.GPIOH1ReadUseNotUseStateCheckBox.TabIndex = 21
        Me.GPIOH1ReadUseNotUseStateCheckBox.Text = "GPIOH1 Use(Checked) Not Use Read State"
        Me.GPIOH1ReadUseNotUseStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH2ReadUseNotUseStateCheckBox
        '
        Me.GPIOH2ReadUseNotUseStateCheckBox.AutoSize = True
        Me.GPIOH2ReadUseNotUseStateCheckBox.Location = New System.Drawing.Point(287, 457)
        Me.GPIOH2ReadUseNotUseStateCheckBox.Name = "GPIOH2ReadUseNotUseStateCheckBox"
        Me.GPIOH2ReadUseNotUseStateCheckBox.Size = New System.Drawing.Size(236, 17)
        Me.GPIOH2ReadUseNotUseStateCheckBox.TabIndex = 22
        Me.GPIOH2ReadUseNotUseStateCheckBox.Text = "GPIOH2 Use(Checked) Not Use Read State"
        Me.GPIOH2ReadUseNotUseStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH3ReadUseNotUseStateCheckBox
        '
        Me.GPIOH3ReadUseNotUseStateCheckBox.AutoSize = True
        Me.GPIOH3ReadUseNotUseStateCheckBox.Location = New System.Drawing.Point(287, 493)
        Me.GPIOH3ReadUseNotUseStateCheckBox.Name = "GPIOH3ReadUseNotUseStateCheckBox"
        Me.GPIOH3ReadUseNotUseStateCheckBox.Size = New System.Drawing.Size(236, 17)
        Me.GPIOH3ReadUseNotUseStateCheckBox.TabIndex = 23
        Me.GPIOH3ReadUseNotUseStateCheckBox.Text = "GPIOH3 Use(Checked) Not Use Read State"
        Me.GPIOH3ReadUseNotUseStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH0InputLowHighReadStateCheckBox
        '
        Me.GPIOH0InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOH0InputLowHighReadStateCheckBox.Enabled = False
        Me.GPIOH0InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(297, 400)
        Me.GPIOH0InputLowHighReadStateCheckBox.Name = "GPIOH0InputLowHighReadStateCheckBox"
        Me.GPIOH0InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(247, 17)
        Me.GPIOH0InputLowHighReadStateCheckBox.TabIndex = 24
        Me.GPIOH0InputLowHighReadStateCheckBox.Text = "GPIOH0 Input Low High(Checked) Read State"
        Me.GPIOH0InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH1InputLowHighReadStateCheckBox
        '
        Me.GPIOH1InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOH1InputLowHighReadStateCheckBox.Enabled = False
        Me.GPIOH1InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(297, 434)
        Me.GPIOH1InputLowHighReadStateCheckBox.Name = "GPIOH1InputLowHighReadStateCheckBox"
        Me.GPIOH1InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(247, 17)
        Me.GPIOH1InputLowHighReadStateCheckBox.TabIndex = 25
        Me.GPIOH1InputLowHighReadStateCheckBox.Text = "GPIOH1 Input Low High(Checked) Read State"
        Me.GPIOH1InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH2InputLowHighReadStateCheckBox
        '
        Me.GPIOH2InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOH2InputLowHighReadStateCheckBox.Enabled = False
        Me.GPIOH2InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(297, 470)
        Me.GPIOH2InputLowHighReadStateCheckBox.Name = "GPIOH2InputLowHighReadStateCheckBox"
        Me.GPIOH2InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(247, 17)
        Me.GPIOH2InputLowHighReadStateCheckBox.TabIndex = 26
        Me.GPIOH2InputLowHighReadStateCheckBox.Text = "GPIOH2 Input Low High(Checked) Read State"
        Me.GPIOH2InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH3InputLowHighReadStateCheckBox
        '
        Me.GPIOH3InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOH3InputLowHighReadStateCheckBox.Enabled = False
        Me.GPIOH3InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(297, 505)
        Me.GPIOH3InputLowHighReadStateCheckBox.Name = "GPIOH3InputLowHighReadStateCheckBox"
        Me.GPIOH3InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(247, 17)
        Me.GPIOH3InputLowHighReadStateCheckBox.TabIndex = 27
        Me.GPIOH3InputLowHighReadStateCheckBox.Text = "GPIOH3 Input Low High(Checked) Read State"
        Me.GPIOH3InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'ChannelLabel
        '
        Me.ChannelLabel.AutoSize = True
        Me.ChannelLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ChannelLabel.Location = New System.Drawing.Point(26, 47)
        Me.ChannelLabel.Name = "ChannelLabel"
        Me.ChannelLabel.Size = New System.Drawing.Size(53, 13)
        Me.ChannelLabel.TabIndex = 28
        Me.ChannelLabel.Text = "Channel"
        '
        'ChannelComboBox
        '
        Me.ChannelComboBox.FormattingEnabled = True
        Me.ChannelComboBox.Location = New System.Drawing.Point(85, 44)
        Me.ChannelComboBox.Name = "ChannelComboBox"
        Me.ChannelComboBox.Size = New System.Drawing.Size(42, 21)
        Me.ChannelComboBox.TabIndex = 29
        '
        'DeviceNameLabel
        '
        Me.DeviceNameLabel.AutoSize = True
        Me.DeviceNameLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.DeviceNameLabel.Location = New System.Drawing.Point(26, 143)
        Me.DeviceNameLabel.Name = "DeviceNameLabel"
        Me.DeviceNameLabel.Size = New System.Drawing.Size(98, 13)
        Me.DeviceNameLabel.TabIndex = 30
        Me.DeviceNameLabel.Text = "Device Name = "
        '
        'HiSpeedDeviceTypeGroupBox
        '
        Me.HiSpeedDeviceTypeGroupBox.Controls.Add(Me.FT4232HRadioButton)
        Me.HiSpeedDeviceTypeGroupBox.Controls.Add(Me.FT2232HRadioButton)
        Me.HiSpeedDeviceTypeGroupBox.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.HiSpeedDeviceTypeGroupBox.Location = New System.Drawing.Point(29, 193)
        Me.HiSpeedDeviceTypeGroupBox.Name = "HiSpeedDeviceTypeGroupBox"
        Me.HiSpeedDeviceTypeGroupBox.Size = New System.Drawing.Size(178, 55)
        Me.HiSpeedDeviceTypeGroupBox.TabIndex = 31
        Me.HiSpeedDeviceTypeGroupBox.TabStop = False
        Me.HiSpeedDeviceTypeGroupBox.Text = "Hi Speed Device Type"
        '
        'FT4232HRadioButton
        '
        Me.FT4232HRadioButton.AutoSize = True
        Me.FT4232HRadioButton.Enabled = False
        Me.FT4232HRadioButton.Location = New System.Drawing.Point(91, 20)
        Me.FT4232HRadioButton.Name = "FT4232HRadioButton"
        Me.FT4232HRadioButton.Size = New System.Drawing.Size(77, 17)
        Me.FT4232HRadioButton.TabIndex = 1
        Me.FT4232HRadioButton.TabStop = True
        Me.FT4232HRadioButton.Text = "FT4232H"
        Me.FT4232HRadioButton.UseVisualStyleBackColor = True
        '
        'FT2232HRadioButton
        '
        Me.FT2232HRadioButton.AutoSize = True
        Me.FT2232HRadioButton.Enabled = False
        Me.FT2232HRadioButton.Location = New System.Drawing.Point(7, 20)
        Me.FT2232HRadioButton.Name = "FT2232HRadioButton"
        Me.FT2232HRadioButton.Size = New System.Drawing.Size(77, 17)
        Me.FT2232HRadioButton.TabIndex = 0
        Me.FT2232HRadioButton.TabStop = True
        Me.FT2232HRadioButton.Text = "FT2232H"
        Me.FT2232HRadioButton.UseVisualStyleBackColor = True
        '
        'MainMenuStrip
        '
        Me.MainMenuStrip.Items.AddRange(New System.Windows.Forms.ToolStripItem() {Me.OptionsMenuItem})
        Me.MainMenuStrip.Location = New System.Drawing.Point(0, 0)
        Me.MainMenuStrip.Name = "MainMenuStrip"
        Me.MainMenuStrip.Size = New System.Drawing.Size(889, 24)
        Me.MainMenuStrip.TabIndex = 32
        '
        'OptionsMenuItem
        '
        Me.OptionsMenuItem.DropDownItems.AddRange(New System.Windows.Forms.ToolStripItem() {Me.CommandSequenceMenuItem, Me.ToolStripSeparator1, Me.ExitMenuItem})
        Me.OptionsMenuItem.Name = "OptionsMenuItem"
        Me.OptionsMenuItem.Size = New System.Drawing.Size(56, 20)
        Me.OptionsMenuItem.Text = "Options"
        '
        'CommandSequenceMenuItem
        '
        Me.CommandSequenceMenuItem.Checked = True
        Me.CommandSequenceMenuItem.CheckState = System.Windows.Forms.CheckState.Checked
        Me.CommandSequenceMenuItem.Name = "CommandSequenceMenuItem"
        Me.CommandSequenceMenuItem.Size = New System.Drawing.Size(171, 22)
        Me.CommandSequenceMenuItem.Text = "Cmd Seq"
        '
        'ToolStripSeparator1
        '
        Me.ToolStripSeparator1.Name = "ToolStripSeparator1"
        Me.ToolStripSeparator1.Size = New System.Drawing.Size(168, 6)
        '
        'ExitMenuItem
        '
        Me.ExitMenuItem.Name = "ExitMenuItem"
        Me.ExitMenuItem.ShortcutKeys = CType(((System.Windows.Forms.Keys.Control Or System.Windows.Forms.Keys.Shift) _
                    Or System.Windows.Forms.Keys.E), System.Windows.Forms.Keys)
        Me.ExitMenuItem.Size = New System.Drawing.Size(171, 22)
        Me.ExitMenuItem.Text = "Exit"
        '
        'PassFailureStatusStrip
        '
        Me.PassFailureStatusStrip.Items.AddRange(New System.Windows.Forms.ToolStripItem() {Me.PassFailStatusLabel, Me.PassFailResultsStatusLabel})
        Me.PassFailureStatusStrip.Location = New System.Drawing.Point(0, 595)
        Me.PassFailureStatusStrip.Name = "PassFailureStatusStrip"
        Me.PassFailureStatusStrip.Size = New System.Drawing.Size(889, 22)
        Me.PassFailureStatusStrip.TabIndex = 33
        '
        'PassFailStatusLabel
        '
        Me.PassFailStatusLabel.BorderSides = System.Windows.Forms.ToolStripStatusLabelBorderSides.Right
        Me.PassFailStatusLabel.Font = New System.Drawing.Font("Tahoma", 8.25!, System.Drawing.FontStyle.Bold)
        Me.PassFailStatusLabel.Name = "PassFailStatusLabel"
        Me.PassFailStatusLabel.Size = New System.Drawing.Size(121, 17)
        Me.PassFailStatusLabel.Text = "Pass/Failure Status"
        '
        'PassFailResultsStatusLabel
        '
        Me.PassFailResultsStatusLabel.Name = "PassFailResultsStatusLabel"
        Me.PassFailResultsStatusLabel.Size = New System.Drawing.Size(0, 17)
        '
        'GPIOH4InputOutputInitialStateCheckBox
        '
        Me.GPIOH4InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOH4InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOH4InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOH4InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(287, 199)
        Me.GPIOH4InputOutputInitialStateCheckBox.Name = "GPIOH4InputOutputInitialStateCheckBox"
        Me.GPIOH4InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(232, 17)
        Me.GPIOH4InputOutputInitialStateCheckBox.TabIndex = 34
        Me.GPIOH4InputOutputInitialStateCheckBox.Text = "GPIOH4 Input Output(Checked) Initial State"
        Me.GPIOH4InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH4OutputLowHighInitialStateCheckBox
        '
        Me.GPIOH4OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOH4OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(297, 213)
        Me.GPIOH4OutputLowHighInitialStateCheckBox.Name = "GPIOH4OutputLowHighInitialStateCheckBox"
        Me.GPIOH4OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(253, 17)
        Me.GPIOH4OutputLowHighInitialStateCheckBox.TabIndex = 35
        Me.GPIOH4OutputLowHighInitialStateCheckBox.Text = "GPIOH4 Output Low High(Checked) Initial State"
        Me.GPIOH4OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH5InputOutputInitialStateCheckBox
        '
        Me.GPIOH5InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOH5InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOH5InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOH5InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(287, 237)
        Me.GPIOH5InputOutputInitialStateCheckBox.Name = "GPIOH5InputOutputInitialStateCheckBox"
        Me.GPIOH5InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(232, 17)
        Me.GPIOH5InputOutputInitialStateCheckBox.TabIndex = 36
        Me.GPIOH5InputOutputInitialStateCheckBox.Text = "GPIOH5 Input Output(Checked) Initial State"
        Me.GPIOH5InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH5OutputLowHighInitialStateCheckBox
        '
        Me.GPIOH5OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOH5OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(297, 251)
        Me.GPIOH5OutputLowHighInitialStateCheckBox.Name = "GPIOH5OutputLowHighInitialStateCheckBox"
        Me.GPIOH5OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(253, 17)
        Me.GPIOH5OutputLowHighInitialStateCheckBox.TabIndex = 37
        Me.GPIOH5OutputLowHighInitialStateCheckBox.Text = "GPIOH5 Output Low High(Checked) Initial State"
        Me.GPIOH5OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH6InputOutputInitialStateCheckBox
        '
        Me.GPIOH6InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOH6InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOH6InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOH6InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(287, 275)
        Me.GPIOH6InputOutputInitialStateCheckBox.Name = "GPIOH6InputOutputInitialStateCheckBox"
        Me.GPIOH6InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(232, 17)
        Me.GPIOH6InputOutputInitialStateCheckBox.TabIndex = 38
        Me.GPIOH6InputOutputInitialStateCheckBox.Text = "GPIOH6 Input Output(Checked) Initial State"
        Me.GPIOH6InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH6OutputLowHighInitialStateCheckBox
        '
        Me.GPIOH6OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOH6OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(297, 290)
        Me.GPIOH6OutputLowHighInitialStateCheckBox.Name = "GPIOH6OutputLowHighInitialStateCheckBox"
        Me.GPIOH6OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(253, 17)
        Me.GPIOH6OutputLowHighInitialStateCheckBox.TabIndex = 39
        Me.GPIOH6OutputLowHighInitialStateCheckBox.Text = "GPIOH6 Output Low High(Checked) Initial State"
        Me.GPIOH6OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH7InputOutputInitialStateCheckBox
        '
        Me.GPIOH7InputOutputInitialStateCheckBox.AutoSize = True
        Me.GPIOH7InputOutputInitialStateCheckBox.Checked = True
        Me.GPIOH7InputOutputInitialStateCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.GPIOH7InputOutputInitialStateCheckBox.Location = New System.Drawing.Point(287, 314)
        Me.GPIOH7InputOutputInitialStateCheckBox.Name = "GPIOH7InputOutputInitialStateCheckBox"
        Me.GPIOH7InputOutputInitialStateCheckBox.Size = New System.Drawing.Size(232, 17)
        Me.GPIOH7InputOutputInitialStateCheckBox.TabIndex = 40
        Me.GPIOH7InputOutputInitialStateCheckBox.Text = "GPIOH7 Input Output(Checked) Initial State"
        Me.GPIOH7InputOutputInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH7OutputLowHighInitialStateCheckBox
        '
        Me.GPIOH7OutputLowHighInitialStateCheckBox.AutoSize = True
        Me.GPIOH7OutputLowHighInitialStateCheckBox.Location = New System.Drawing.Point(297, 329)
        Me.GPIOH7OutputLowHighInitialStateCheckBox.Name = "GPIOH7OutputLowHighInitialStateCheckBox"
        Me.GPIOH7OutputLowHighInitialStateCheckBox.Size = New System.Drawing.Size(253, 17)
        Me.GPIOH7OutputLowHighInitialStateCheckBox.TabIndex = 41
        Me.GPIOH7OutputLowHighInitialStateCheckBox.Text = "GPIOH7 Output Low High(Checked) Initial State"
        Me.GPIOH7OutputLowHighInitialStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH4WriteUseNotUseStateCheckBox
        '
        Me.GPIOH4WriteUseNotUseStateCheckBox.AutoSize = True
        Me.GPIOH4WriteUseNotUseStateCheckBox.Location = New System.Drawing.Point(577, 200)
        Me.GPIOH4WriteUseNotUseStateCheckBox.Name = "GPIOH4WriteUseNotUseStateCheckBox"
        Me.GPIOH4WriteUseNotUseStateCheckBox.Size = New System.Drawing.Size(235, 17)
        Me.GPIOH4WriteUseNotUseStateCheckBox.TabIndex = 42
        Me.GPIOH4WriteUseNotUseStateCheckBox.Text = "GPIOH4 Use(Checked) Not Use Write State"
        Me.GPIOH4WriteUseNotUseStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH4OutputLowHighWriteStateCheckBox
        '
        Me.GPIOH4OutputLowHighWriteStateCheckBox.AutoSize = True
        Me.GPIOH4OutputLowHighWriteStateCheckBox.Enabled = False
        Me.GPIOH4OutputLowHighWriteStateCheckBox.Location = New System.Drawing.Point(587, 214)
        Me.GPIOH4OutputLowHighWriteStateCheckBox.Name = "GPIOH4OutputLowHighWriteStateCheckBox"
        Me.GPIOH4OutputLowHighWriteStateCheckBox.Size = New System.Drawing.Size(254, 17)
        Me.GPIOH4OutputLowHighWriteStateCheckBox.TabIndex = 43
        Me.GPIOH4OutputLowHighWriteStateCheckBox.Text = "GPIOH4 Output Low High(Checked) Write State"
        Me.GPIOH4OutputLowHighWriteStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH5WriteUseNotUseStateCheckBox
        '
        Me.GPIOH5WriteUseNotUseStateCheckBox.AutoSize = True
        Me.GPIOH5WriteUseNotUseStateCheckBox.Location = New System.Drawing.Point(577, 238)
        Me.GPIOH5WriteUseNotUseStateCheckBox.Name = "GPIOH5WriteUseNotUseStateCheckBox"
        Me.GPIOH5WriteUseNotUseStateCheckBox.Size = New System.Drawing.Size(235, 17)
        Me.GPIOH5WriteUseNotUseStateCheckBox.TabIndex = 44
        Me.GPIOH5WriteUseNotUseStateCheckBox.Text = "GPIOH5 Use(Checked) Not Use Write State"
        Me.GPIOH5WriteUseNotUseStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH5OutputLowHighWriteStateCheckBox
        '
        Me.GPIOH5OutputLowHighWriteStateCheckBox.AutoSize = True
        Me.GPIOH5OutputLowHighWriteStateCheckBox.Enabled = False
        Me.GPIOH5OutputLowHighWriteStateCheckBox.Location = New System.Drawing.Point(587, 251)
        Me.GPIOH5OutputLowHighWriteStateCheckBox.Name = "GPIOH5OutputLowHighWriteStateCheckBox"
        Me.GPIOH5OutputLowHighWriteStateCheckBox.Size = New System.Drawing.Size(254, 17)
        Me.GPIOH5OutputLowHighWriteStateCheckBox.TabIndex = 45
        Me.GPIOH5OutputLowHighWriteStateCheckBox.Text = "GPIOH5 Output Low High(Checked) Write State"
        Me.GPIOH5OutputLowHighWriteStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH6WriteUseNotUseStateCheckBox
        '
        Me.GPIOH6WriteUseNotUseStateCheckBox.AutoSize = True
        Me.GPIOH6WriteUseNotUseStateCheckBox.Location = New System.Drawing.Point(577, 275)
        Me.GPIOH6WriteUseNotUseStateCheckBox.Name = "GPIOH6WriteUseNotUseStateCheckBox"
        Me.GPIOH6WriteUseNotUseStateCheckBox.Size = New System.Drawing.Size(235, 17)
        Me.GPIOH6WriteUseNotUseStateCheckBox.TabIndex = 46
        Me.GPIOH6WriteUseNotUseStateCheckBox.Text = "GPIOH6 Use(Checked) Not Use Write State"
        Me.GPIOH6WriteUseNotUseStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH6OutputLowHighWriteStateCheckBox
        '
        Me.GPIOH6OutputLowHighWriteStateCheckBox.AutoSize = True
        Me.GPIOH6OutputLowHighWriteStateCheckBox.Enabled = False
        Me.GPIOH6OutputLowHighWriteStateCheckBox.Location = New System.Drawing.Point(587, 290)
        Me.GPIOH6OutputLowHighWriteStateCheckBox.Name = "GPIOH6OutputLowHighWriteStateCheckBox"
        Me.GPIOH6OutputLowHighWriteStateCheckBox.Size = New System.Drawing.Size(254, 17)
        Me.GPIOH6OutputLowHighWriteStateCheckBox.TabIndex = 47
        Me.GPIOH6OutputLowHighWriteStateCheckBox.Text = "GPIOH6 Output Low High(Checked) Write State"
        Me.GPIOH6OutputLowHighWriteStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH7WriteUseNotUseStateCheckBox
        '
        Me.GPIOH7WriteUseNotUseStateCheckBox.AutoSize = True
        Me.GPIOH7WriteUseNotUseStateCheckBox.Location = New System.Drawing.Point(577, 314)
        Me.GPIOH7WriteUseNotUseStateCheckBox.Name = "GPIOH7WriteUseNotUseStateCheckBox"
        Me.GPIOH7WriteUseNotUseStateCheckBox.Size = New System.Drawing.Size(235, 17)
        Me.GPIOH7WriteUseNotUseStateCheckBox.TabIndex = 48
        Me.GPIOH7WriteUseNotUseStateCheckBox.Text = "GPIOH7 Use(Checked) Not Use Write State"
        Me.GPIOH7WriteUseNotUseStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH7OutputLowHighWriteStateCheckBox
        '
        Me.GPIOH7OutputLowHighWriteStateCheckBox.AutoSize = True
        Me.GPIOH7OutputLowHighWriteStateCheckBox.Enabled = False
        Me.GPIOH7OutputLowHighWriteStateCheckBox.Location = New System.Drawing.Point(587, 329)
        Me.GPIOH7OutputLowHighWriteStateCheckBox.Name = "GPIOH7OutputLowHighWriteStateCheckBox"
        Me.GPIOH7OutputLowHighWriteStateCheckBox.Size = New System.Drawing.Size(254, 17)
        Me.GPIOH7OutputLowHighWriteStateCheckBox.TabIndex = 49
        Me.GPIOH7OutputLowHighWriteStateCheckBox.Text = "GPIOH7 Output Low High(Checked) Write State"
        Me.GPIOH7OutputLowHighWriteStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH4ReadUseNotUseStateCheckBox
        '
        Me.GPIOH4ReadUseNotUseStateCheckBox.AutoSize = True
        Me.GPIOH4ReadUseNotUseStateCheckBox.Location = New System.Drawing.Point(577, 386)
        Me.GPIOH4ReadUseNotUseStateCheckBox.Name = "GPIOH4ReadUseNotUseStateCheckBox"
        Me.GPIOH4ReadUseNotUseStateCheckBox.Size = New System.Drawing.Size(236, 17)
        Me.GPIOH4ReadUseNotUseStateCheckBox.TabIndex = 50
        Me.GPIOH4ReadUseNotUseStateCheckBox.Text = "GPIOH4 Use(Checked) Not Use Read State"
        Me.GPIOH4ReadUseNotUseStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH4InputLowHighReadStateCheckBox
        '
        Me.GPIOH4InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOH4InputLowHighReadStateCheckBox.Enabled = False
        Me.GPIOH4InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(587, 400)
        Me.GPIOH4InputLowHighReadStateCheckBox.Name = "GPIOH4InputLowHighReadStateCheckBox"
        Me.GPIOH4InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(247, 17)
        Me.GPIOH4InputLowHighReadStateCheckBox.TabIndex = 51
        Me.GPIOH4InputLowHighReadStateCheckBox.Text = "GPIOH4 Input Low High(Checked) Read State"
        Me.GPIOH4InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH5ReadUseNotUseStateCheckBox
        '
        Me.GPIOH5ReadUseNotUseStateCheckBox.AutoSize = True
        Me.GPIOH5ReadUseNotUseStateCheckBox.Location = New System.Drawing.Point(577, 421)
        Me.GPIOH5ReadUseNotUseStateCheckBox.Name = "GPIOH5ReadUseNotUseStateCheckBox"
        Me.GPIOH5ReadUseNotUseStateCheckBox.Size = New System.Drawing.Size(236, 17)
        Me.GPIOH5ReadUseNotUseStateCheckBox.TabIndex = 52
        Me.GPIOH5ReadUseNotUseStateCheckBox.Text = "GPIOH5 Use(Checked) Not Use Read State"
        Me.GPIOH5ReadUseNotUseStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH5InputLowHighReadStateCheckBox
        '
        Me.GPIOH5InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOH5InputLowHighReadStateCheckBox.Enabled = False
        Me.GPIOH5InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(587, 434)
        Me.GPIOH5InputLowHighReadStateCheckBox.Name = "GPIOH5InputLowHighReadStateCheckBox"
        Me.GPIOH5InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(247, 17)
        Me.GPIOH5InputLowHighReadStateCheckBox.TabIndex = 53
        Me.GPIOH5InputLowHighReadStateCheckBox.Text = "GPIOH5 Input Low High(Checked) Read State"
        Me.GPIOH5InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH6ReadUseNotUseStateCheckBox
        '
        Me.GPIOH6ReadUseNotUseStateCheckBox.AutoSize = True
        Me.GPIOH6ReadUseNotUseStateCheckBox.Location = New System.Drawing.Point(577, 457)
        Me.GPIOH6ReadUseNotUseStateCheckBox.Name = "GPIOH6ReadUseNotUseStateCheckBox"
        Me.GPIOH6ReadUseNotUseStateCheckBox.Size = New System.Drawing.Size(236, 17)
        Me.GPIOH6ReadUseNotUseStateCheckBox.TabIndex = 54
        Me.GPIOH6ReadUseNotUseStateCheckBox.Text = "GPIOH6 Use(Checked) Not Use Read State"
        Me.GPIOH6ReadUseNotUseStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH6InputLowHighReadStateCheckBox
        '
        Me.GPIOH6InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOH6InputLowHighReadStateCheckBox.Enabled = False
        Me.GPIOH6InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(587, 470)
        Me.GPIOH6InputLowHighReadStateCheckBox.Name = "GPIOH6InputLowHighReadStateCheckBox"
        Me.GPIOH6InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(247, 17)
        Me.GPIOH6InputLowHighReadStateCheckBox.TabIndex = 55
        Me.GPIOH6InputLowHighReadStateCheckBox.Text = "GPIOH6 Input Low High(Checked) Read State"
        Me.GPIOH6InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH7ReadUseNotUseStateCheckBox
        '
        Me.GPIOH7ReadUseNotUseStateCheckBox.AutoSize = True
        Me.GPIOH7ReadUseNotUseStateCheckBox.Location = New System.Drawing.Point(577, 493)
        Me.GPIOH7ReadUseNotUseStateCheckBox.Name = "GPIOH7ReadUseNotUseStateCheckBox"
        Me.GPIOH7ReadUseNotUseStateCheckBox.Size = New System.Drawing.Size(236, 17)
        Me.GPIOH7ReadUseNotUseStateCheckBox.TabIndex = 56
        Me.GPIOH7ReadUseNotUseStateCheckBox.Text = "GPIOH7 Use(Checked) Not Use Read State"
        Me.GPIOH7ReadUseNotUseStateCheckBox.UseVisualStyleBackColor = True
        '
        'GPIOH7InputLowHighReadStateCheckBox
        '
        Me.GPIOH7InputLowHighReadStateCheckBox.AutoSize = True
        Me.GPIOH7InputLowHighReadStateCheckBox.Enabled = False
        Me.GPIOH7InputLowHighReadStateCheckBox.Location = New System.Drawing.Point(587, 505)
        Me.GPIOH7InputLowHighReadStateCheckBox.Name = "GPIOH7InputLowHighReadStateCheckBox"
        Me.GPIOH7InputLowHighReadStateCheckBox.Size = New System.Drawing.Size(247, 17)
        Me.GPIOH7InputLowHighReadStateCheckBox.TabIndex = 57
        Me.GPIOH7InputLowHighReadStateCheckBox.Text = "GPIOH7 Input Low High(Checked) Read State"
        Me.GPIOH7InputLowHighReadStateCheckBox.UseVisualStyleBackColor = True
        '
        'MainForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(889, 617)
        Me.Controls.Add(Me.GPIOH7InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOH7ReadUseNotUseStateCheckBox)
        Me.Controls.Add(Me.GPIOH6InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOH6ReadUseNotUseStateCheckBox)
        Me.Controls.Add(Me.GPIOH5InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOH5ReadUseNotUseStateCheckBox)
        Me.Controls.Add(Me.GPIOH4InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOH4ReadUseNotUseStateCheckBox)
        Me.Controls.Add(Me.GPIOH7OutputLowHighWriteStateCheckBox)
        Me.Controls.Add(Me.GPIOH7WriteUseNotUseStateCheckBox)
        Me.Controls.Add(Me.GPIOH6OutputLowHighWriteStateCheckBox)
        Me.Controls.Add(Me.GPIOH6WriteUseNotUseStateCheckBox)
        Me.Controls.Add(Me.GPIOH5OutputLowHighWriteStateCheckBox)
        Me.Controls.Add(Me.GPIOH5WriteUseNotUseStateCheckBox)
        Me.Controls.Add(Me.GPIOH4OutputLowHighWriteStateCheckBox)
        Me.Controls.Add(Me.GPIOH4WriteUseNotUseStateCheckBox)
        Me.Controls.Add(Me.GPIOH7OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH7InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH6OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH6InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH5OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH5InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH4OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH4InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.PassFailureStatusStrip)
        Me.Controls.Add(Me.HiSpeedDeviceTypeGroupBox)
        Me.Controls.Add(Me.DeviceNameLabel)
        Me.Controls.Add(Me.ChannelComboBox)
        Me.Controls.Add(Me.ChannelLabel)
        Me.Controls.Add(Me.GPIOH3InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOH2InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOH1InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOH0InputLowHighReadStateCheckBox)
        Me.Controls.Add(Me.GPIOH3ReadUseNotUseStateCheckBox)
        Me.Controls.Add(Me.GPIOH2ReadUseNotUseStateCheckBox)
        Me.Controls.Add(Me.GPIOH1ReadUseNotUseStateCheckBox)
        Me.Controls.Add(Me.GPIOH0ReadUseNotUseStateCheckBox)
        Me.Controls.Add(Me.GPIOH0To7OnlyCheckBox)
        Me.Controls.Add(Me.GPIOH3OutputLowHighWriteStateCheckBox)
        Me.Controls.Add(Me.GPIOH3WriteUseNotUseStateCheckBox)
        Me.Controls.Add(Me.GPIOH2OutputLowHighWriteStateCheckBox)
        Me.Controls.Add(Me.GPIOH2WriteUseNotUseStateCheckBox)
        Me.Controls.Add(Me.GPIOH1OutputLowHighWriteStateCheckBox)
        Me.Controls.Add(Me.GPIOH1WriteUseNotUseStateCheckBox)
        Me.Controls.Add(Me.GPIOH3OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH3InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH2OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH2InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH1OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH1InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH0OutputLowHighWriteStateCheckBox)
        Me.Controls.Add(Me.GPIOH0WriteUseNotUseStateCheckBox)
        Me.Controls.Add(Me.GPIOH0OutputLowHighInitialStateCheckBox)
        Me.Controls.Add(Me.GPIOH0InputOutputInitialStateCheckBox)
        Me.Controls.Add(Me.DLLVersionLabel)
        Me.Controls.Add(Me.TestButton)
        Me.Controls.Add(Me.MainMenuStrip)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "MainForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "MainForm"
        Me.HiSpeedDeviceTypeGroupBox.ResumeLayout(False)
        Me.HiSpeedDeviceTypeGroupBox.PerformLayout()
        Me.MainMenuStrip.ResumeLayout(False)
        Me.MainMenuStrip.PerformLayout()
        Me.PassFailureStatusStrip.ResumeLayout(False)
        Me.PassFailureStatusStrip.PerformLayout()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region
    Public Structure FTC_CHIP_SELECT_PINS
        Public bADBUS3ChipSelectPinState As Boolean
        Public bADBUS4GPIOL1PinState As Boolean
        Public bADBUS5GPIOL2PinState As Boolean
        Public bADBUS6GPIOL3PinState As Boolean
        Public bADBUS7GPIOL4PinState As Boolean
    End Structure
    Public Structure FTC_INPUT_OUTPUT_PINS
        Public bPin1InputOutputState As Boolean
        Public bPin1LowHighState As Boolean
        Public bPin2InputOutputState As Boolean
        Public bPin2LowHighState As Boolean
        Public bPin3InputOutputState As Boolean
        Public bPin3LowHighState As Boolean
        Public bPin4InputOutputState As Boolean
        Public bPin4LowHighState As Boolean
    End Structure
    Public Structure FTH_INPUT_OUTPUT_PINS
        Public bPin1InputOutputState As Boolean
        Public bPin1LowHighState As Boolean
        Public bPin2InputOutputState As Boolean
        Public bPin2LowHighState As Boolean
        Public bPin3InputOutputState As Boolean
        Public bPin3LowHighState As Boolean
        Public bPin4InputOutputState As Boolean
        Public bPin4LowHighState As Boolean
        Public bPin5InputOutputState As Boolean
        Public bPin5LowHighState As Boolean
        Public bPin6InputOutputState As Boolean
        Public bPin6LowHighState As Boolean
        Public bPin7InputOutputState As Boolean
        Public bPin7LowHighState As Boolean
        Public bPin8InputOutputState As Boolean
        Public bPin8LowHighState As Boolean
    End Structure
    Public Structure FTC_LOW_HIGH_PINS
        Public bPin1LowHighState As Boolean
        Public bPin2LowHighState As Boolean
        Public bPin3LowHighState As Boolean
        Public bPin4LowHighState As Boolean
    End Structure
    Public Structure FTH_LOW_HIGH_PINS
        Public bPin1LowHighState As Boolean
        Public bPin2LowHighState As Boolean
        Public bPin3LowHighState As Boolean
        Public bPin4LowHighState As Boolean
        Public bPin5LowHighState As Boolean
        Public bPin6LowHighState As Boolean
        Public bPin7LowHighState As Boolean
        Public bPin8LowHighState As Boolean
    End Structure
    Public Structure FTC_INIT_CONDITION
        Public bClockPinState As Boolean
        Public bDataOutPinState As Boolean
        Public bChipSelectPinState As Boolean
        Public ChipSelectPin As Integer
    End Structure
    Public Structure FTC_WAIT_DATA_WRITE
        Public bWaitDataWriteComplete As Boolean
        Public WaitDataWritePin As Integer
        Public bDataWriteCompleteState As Boolean
        Public DataWriteTimeoutmSecs As Integer
    End Structure
    Public Structure FTC_HIGHER_OUTPUT_PINS
        Public bPin1State As Boolean
        Public bPin1ActiveState As Boolean
        Public bPin2State As Boolean
        Public bPin2ActiveState As Boolean
        Public bPin3State As Boolean
        Public bPin3ActiveState As Boolean
        Public bPin4State As Boolean
        Public bPin4ActiveState As Boolean
    End Structure
    Public Structure FTH_HIGHER_OUTPUT_PINS
        Public bPin1State As Boolean
        Public bPin1ActiveState As Boolean
        Public bPin2State As Boolean
        Public bPin2ActiveState As Boolean
        Public bPin3State As Boolean
        Public bPin3ActiveState As Boolean
        Public bPin4State As Boolean
        Public bPin4ActiveState As Boolean
        Public bPin5State As Boolean
        Public bPin5ActiveState As Boolean
        Public bPin6State As Boolean
        Public bPin6ActiveState As Boolean
        Public bPin7State As Boolean
        Public bPin7ActiveState As Boolean
        Public bPin8State As Boolean
        Public bPin8ActiveState As Boolean
    End Structure
    Public Structure FTC_CLOSE_FINAL_STATE_PINS
        Public bTCKPinState As Boolean
        Public bTCKPinActiveState As Boolean
        Public bTDIPinState As Boolean
        Public bTDIPinActiveState As Boolean
        Public bTMSPinState As Boolean
        Public bTMSPinActiveState As Boolean
    End Structure

    Private Declare Function SPI_GetNumHiSpeedDevices Lib "ftcspi" (ByRef NumHiSpeedDevices As Long) As Integer
    Private Declare Function SPI_GetHiSpeedDeviceNameLocIDChannel Lib "ftcspi" (ByVal DeviceNameIndex As Integer, ByVal DeviceName As String, ByVal DeviceNameBufferSize As Integer, ByRef lpLocationID As Long, ByVal Channel As String, ByVal ChannelBufferSize As Integer, ByRef lpHiSpeedDeviceType As Long) As Integer
    Private Declare Function SPI_OpenHiSpeedDevice Lib "ftcspi" (ByVal DeviceName As String, ByVal LocationID As Integer, ByVal Channel As String, ByRef ftHandle As Long) As Integer
    Private Declare Function SPI_GetHiSpeedDeviceType Lib "ftcspi" (ByVal ftHandle As Integer, ByRef lpHiSpeedDeviceType As Long) As Integer
    Private Declare Function SPI_Close Lib "ftcspi" (ByVal ftHandle As Integer) As Integer
    Private Declare Function SPI_CloseDevice Lib "ftcspi" (ByVal ftHandle As Integer, ByRef pCloseFinalStatePinsData As FTC_CLOSE_FINAL_STATE_PINS) As Integer
    Private Declare Function SPI_InitDevice Lib "ftcspi" (ByVal ftHandle As Integer, ByVal ClockDivisor As Integer) As Integer
    Private Declare Function SPI_TurnOnDivideByFiveClockingHiSpeedDevice Lib "ftcspi" (ByVal ftHandle As Integer) As Integer
    Private Declare Function SPI_TurnOffDivideByFiveClockingHiSpeedDevice Lib "ftcspi" (ByVal ftHandle As Integer) As Integer
    Private Declare Function SPI_SetDeviceLatencyTimer Lib "ftcspi" (ByVal ftHandle As Integer, ByVal TimerValue As Byte) As Integer
    Private Declare Function SPI_GetDeviceLatencyTimer Lib "ftcspi" (ByVal ftHandle As Integer, ByRef lpTimerValue As Byte) As Integer
    Private Declare Function SPI_GetHiSpeedDeviceClock Lib "ftcspi" (ByVal ClockDivisor As Integer, ByRef lpClockFrequencyHz As Long) As Integer
    Private Declare Function SPI_GetClock Lib "ftcspi" (ByVal ClockDivisor As Integer, ByRef lpClockFrequencyHz As Long) As Integer
    Private Declare Function SPI_SetClock Lib "ftcspi" (ByVal ftHandle As Integer, ByVal ClockDivisor As Integer, ByRef lpClockFrequencyHz As Long) As Integer
    Private Declare Function SPI_SetLoopback Lib "ftcspi" (ByVal ftHandle As Integer, ByVal bLoopbackState As Boolean) As Integer
    Private Declare Function SPI_SetHiSpeedDeviceGPIOs Lib "ftcspi" (ByVal ftHandle As Integer, ByRef pChipSelectsDisableStates As FTC_CHIP_SELECT_PINS, ByRef pHighInputOutputPinsData As FTH_INPUT_OUTPUT_PINS) As Integer
    Private Declare Function SPI_GetHiSpeedDeviceGPIOs Lib "ftcspi" (ByVal ftHandle As Integer, ByRef pHighPinsInputData As FTH_LOW_HIGH_PINS) As Integer
    Private Declare Function SPI_WriteHiSpeedDevice Lib "ftcspi" (ByVal ftHandle As Integer, ByRef pWriteStartCondition As FTC_INIT_CONDITION, ByVal bClockOutDataBitsMSBFirst As Boolean, ByVal bClockOutDataBitsPosEdge As Boolean, ByVal NumControlBitsToWrite As Integer, ByVal WriteControlBuffer() As Byte, ByVal NumControlBytesToWrite As Integer, ByVal bWriteDataBits As Boolean, ByVal NumDataBitsToWrite As Integer, ByVal WriteDataBuffer() As Byte, ByVal NumDataBytesToWrite As Integer, ByRef pWaitDataWriteComplete As FTC_WAIT_DATA_WRITE, ByRef pHighPinsWriteActiveStates As FTH_HIGHER_OUTPUT_PINS) As Integer
    Private Declare Function SPI_ReadHiSpeedDevice Lib "ftcspi" (ByVal ftHandle As Integer, ByRef pReadStartCondition As FTC_INIT_CONDITION, ByVal bClockOutDataBitsMSBFirst As Boolean, ByVal bClockOutDataBitsPosEdge As Boolean, ByVal NumControlBitsToWrite As Integer, ByVal WriteControlBuffer() As Byte, ByVal NumControlBytesToWrite As Integer, ByVal bClockInDataBitsMSBFirst As Boolean, ByVal bClockInDataBitsPosEdge As Boolean, ByVal NumDataBitsToRead As Integer, ByVal ReadDataBuffer() As Byte, ByRef lpNumDataBytesReturned As Long, ByRef pHighPinsWriteActiveStates As FTH_HIGHER_OUTPUT_PINS) As Integer
    Private Declare Function SPI_ClearDeviceCmdSequence Lib "ftcspi" (ByVal ftHandle As Integer) As Integer
    Private Declare Function SPI_AddHiSpeedDeviceWriteCmd Lib "ftcspi" (ByVal ftHandle As Integer, ByRef pWriteStartCondition As FTC_INIT_CONDITION, ByVal bClockOutDataBitsMSBFirst As Boolean, ByVal bClockOutDataBitsPosEdge As Boolean, ByVal NumControlBitsToWrite As Integer, ByVal WriteControlBuffer() As Byte, ByVal NumControlBytesToWrite As Integer, ByVal bWriteDataBits As Boolean, ByVal NumDataBitsToWrite As Integer, ByVal WriteDataBuffer() As Byte, ByVal NumDataBytesToWrite As Integer, ByRef pHighPinsWriteActiveStates As FTH_HIGHER_OUTPUT_PINS) As Integer
    Private Declare Function SPI_AddHiSpeedDeviceReadCmd Lib "ftcspi" (ByVal ftHandle As Integer, ByRef pReadStartCondition As FTC_INIT_CONDITION, ByVal bClockOutDataBitsMSBFirst As Boolean, ByVal bClockOutDataBitsPosEdge As Boolean, ByVal NumControlBitsToWrite As Integer, ByVal WriteControlBuffer() As Byte, ByVal NumControlBytesToWrite As Integer, ByVal bClockInDataBitsMSBFirst As Boolean, ByVal bClockInDataBitsPosEdge As Boolean, ByVal NumDataBitsToRead As Integer, ByRef pHighPinsWriteActiveStates As FTH_HIGHER_OUTPUT_PINS) As Integer
    Private Declare Function SPI_ExecuteDeviceCmdSequence Lib "ftcspi" (ByVal ftHandle As Integer, ByVal ReadCmdSequenceDataBuffer() As Byte, ByRef lpNumBytesReturned As Long) As Integer
    Private Declare Function SPI_GetDllVersion Lib "ftcspi" (ByVal DllVersion As String, ByVal BufferSize As Integer) As Integer
    Private Declare Function SPI_GetErrorCodeString Lib "ftcspi" (ByVal Language As String, ByVal StatusCode As Integer, ByVal ErrorMessage As String, ByVal BufferSize As Integer) As Integer

    Private Declare Function Sleep Lib "Kernel32" (ByVal Milliseconds As Integer) As Long

    Private Const FTC_SUCCESS = 0
    Private Const FTC_DEVICE_IN_USE = 27

    Private Const WRITE_CONTROL_BUFFER_SIZE = 256
    Private Const WRITE_DATA_BUFFER_SIZE = 65536
    Private Const READ_DATA_BUFFER_SIZE = 65536
    Private Const READ_CMDS_DATA_BUFFER_SIZE = 131071

    Private Const MAX_NUM_DEVICE_NAME_CHARS = 200
    Private Const MAX_NUM_CHANNEL_CHARS = 5

    Private Const MAX_NUM_DLL_VERSION_CHARS = 10

    Private Const MAX_NUM_ERROR_MESSAGE_CHARS = 200

    Private Const App_Title = "FT2232/FT4232 Hi-Speed SPI Device Visual Basic .NET Test Application"

    Private Const Dll_Version_Label = "FT2232/FT4232 SPI DLL Version = "

    Private Const Device_Name_Label = "Device Name = "

    Private Enum hiSpeedDeviceTypes
        FT2232H_Device_Type = 1
        FT4232H_Device_Type = 2
    End Enum

    Private Const MAX_SPI_93LC56_CHIP_SIZE_IN_WORDS = 128

    ' To communicate with the 93LC56(2048 word) EEPROM, the maximum frequency the clock can be set is 1MHz 
    Private Const MAX_FREQ_93LC56_CLOCK_DIVISOR = 29     ' equivalent to 1MHz

    Private Const ADBUS3ChipSelect = 0

    Private Const ADBUS2DataIn = 0

    Private Const SPIEWENCmdIndex = 0
    Private Const SPIEWDSCmdIndex = 1
    Private Const SPIERALCmdIndex = 2

    Private Const NUM_93LC56B_CMD_CONTOL_BITS = 11
    Private Const NUM_93LC56B_CMD_CONTOL_BYTES = 2

    Private Const NUM_93LC56B_CMD_DATA_BITS = 16
    Private Const NUM_93LC56B_CMD_DATA_BYTES = 2

    Private ftHandle As Integer = 0

    Private Function ConvertDLLStringToVBString(ByRef DLLString As String) As String
        Dim VBString As String
        Dim iCharCntr As Integer = 0
        Dim CharArray() As Char

        While (DLLString.Chars(iCharCntr) <> vbNullChar)
            iCharCntr = iCharCntr + 1
        End While

        CharArray = New Char((iCharCntr - 1)) {}

        iCharCntr = 0
        While (DLLString.Chars(iCharCntr) <> vbNullChar)
            CharArray(iCharCntr) = DLLString.Chars(iCharCntr)
            iCharCntr = iCharCntr + 1
        End While

        VBString = New String(CharArray)

        Return VBString
    End Function

    Private Function TestHiSpeedDeviceClock(ByVal ftHandle As Integer) As Integer
        Dim ftStatus As Integer = FTC_SUCCESS
        Dim ClockFrequencyHz As Long = 0

        ftStatus = SPI_GetHiSpeedDeviceClock(0, ClockFrequencyHz)

        If (ftStatus = FTC_SUCCESS) Then
            ftStatus = SPI_TurnOnDivideByFiveClockingHiSpeedDevice(ftHandle)

            If (ftStatus = FTC_SUCCESS) Then
                ftStatus = SPI_GetHiSpeedDeviceClock(0, ClockFrequencyHz)

                ftStatus = SPI_SetClock(ftHandle, MAX_FREQ_93LC56_CLOCK_DIVISOR, ClockFrequencyHz)

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = SPI_TurnOffDivideByFiveClockingHiSpeedDevice(ftHandle)

                    ftStatus = SPI_SetClock(ftHandle, MAX_FREQ_93LC56_CLOCK_DIVISOR, ClockFrequencyHz)
                End If
            End If
        End If

        Return ftStatus
    End Function

    Private Function SPI_EWEN_EWDS_ERAL_93LC56B_Device(ByVal ftHandle As Integer, ByRef pWriteStartCondition As FTC_INIT_CONDITION, ByVal SPICmdIndex As Integer) As Integer
        Dim ftStatus As Integer = FTC_SUCCESS
        Dim ControlByte1 As Integer = 0
        Dim ControlByte2 As Integer = 0
        Dim WriteControlBuffer() As Byte = New Byte((WRITE_CONTROL_BUFFER_SIZE - 1)) {}
        Dim WriteDataBuffer() As Byte = New Byte((WRITE_DATA_BUFFER_SIZE - 1)) {}
        Dim WaitDataWriteComplete As FTC_WAIT_DATA_WRITE
        Dim HighPinsWriteActiveStates As FTH_HIGHER_OUTPUT_PINS

        Select Case SPICmdIndex
            Case SPIEWENCmdIndex
                ControlByte1 = &H9F ' set up write enable command
            Case SPIEWDSCmdIndex
                ControlByte1 = &H87 ' set up write disable command
            Case SPIERALCmdIndex
                ControlByte1 = &H97 ' set up erase all command
        End Select

        ControlByte2 = &HFF

        WriteControlBuffer(0) = ControlByte1
        WriteControlBuffer(1) = ControlByte2

        WaitDataWriteComplete.bWaitDataWriteComplete = False

        HighPinsWriteActiveStates.bPin1State = Me.GPIOH0WriteUseNotUseStateCheckBox.Checked
        HighPinsWriteActiveStates.bPin1ActiveState = Me.GPIOH0OutputLowHighWriteStateCheckBox.Checked
        HighPinsWriteActiveStates.bPin2State = Me.GPIOH1WriteUseNotUseStateCheckBox.Checked
        HighPinsWriteActiveStates.bPin2ActiveState = Me.GPIOH1OutputLowHighWriteStateCheckBox.Checked
        HighPinsWriteActiveStates.bPin3State = Me.GPIOH2WriteUseNotUseStateCheckBox.Checked
        HighPinsWriteActiveStates.bPin3ActiveState = Me.GPIOH2OutputLowHighWriteStateCheckBox.Checked
        HighPinsWriteActiveStates.bPin4State = Me.GPIOH3WriteUseNotUseStateCheckBox.Checked
        HighPinsWriteActiveStates.bPin4ActiveState = Me.GPIOH3OutputLowHighWriteStateCheckBox.Checked
        HighPinsWriteActiveStates.bPin1State = Me.GPIOH4WriteUseNotUseStateCheckBox.Checked
        HighPinsWriteActiveStates.bPin1ActiveState = Me.GPIOH4OutputLowHighWriteStateCheckBox.Checked
        HighPinsWriteActiveStates.bPin2State = Me.GPIOH5WriteUseNotUseStateCheckBox.Checked
        HighPinsWriteActiveStates.bPin2ActiveState = Me.GPIOH5OutputLowHighWriteStateCheckBox.Checked
        HighPinsWriteActiveStates.bPin3State = Me.GPIOH6WriteUseNotUseStateCheckBox.Checked
        HighPinsWriteActiveStates.bPin3ActiveState = Me.GPIOH6OutputLowHighWriteStateCheckBox.Checked
        HighPinsWriteActiveStates.bPin4State = Me.GPIOH7WriteUseNotUseStateCheckBox.Checked
        HighPinsWriteActiveStates.bPin4ActiveState = Me.GPIOH7OutputLowHighWriteStateCheckBox.Checked

        ftStatus = SPI_WriteHiSpeedDevice(ftHandle, pWriteStartCondition, True, False, 11, WriteControlBuffer, 2, False, 0, WriteDataBuffer, 0, WaitDataWriteComplete, HighPinsWriteActiveStates)

        Return ftStatus
    End Function

    Private Sub TestButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TestButton.Click
        Dim ftStatus As Integer = FTC_SUCCESS
        Dim NumHiSpeedDevices As Long = 0
        Dim HiSpeedDeviceName As String = New String(ChrW(0), MAX_NUM_DEVICE_NAME_CHARS)
        Dim HiSpeedDeviceChannel As String = New String(ChrW(0), MAX_NUM_CHANNEL_CHARS)
        Dim LocationID As Long = 0
        Dim HiSpeedDeviceType As Long = 0
        Dim HSDN As String
        Dim HSCH As String
        Dim HiSpeedDeviceIndex As Long = 0
        Dim bPerformCommandSequence As Boolean = False 'True
        Dim ClockFrequencyHz As Long = 0
        Dim TimerValue As Byte = 0
        Dim bLoopbackState As Boolean = False
        Dim DataWriteType As Integer
        Dim ControlLocAddress1 As Integer
        Dim ControlLocAddress2 As Integer
        Dim WriteDataWordAddress As Integer
        Dim HighInputOutputPinsData As FTH_INPUT_OUTPUT_PINS
        Dim HighPinsInputData As FTH_LOW_HIGH_PINS = New FTH_LOW_HIGH_PINS
        Dim WriteStartCondition As FTC_INIT_CONDITION
        Dim HighPinsWriteActiveStates As FTH_HIGHER_OUTPUT_PINS
        Dim HighPinsReadActiveStates As FTH_HIGHER_OUTPUT_PINS
        Dim ChipSelectsDisableStates As FTC_CHIP_SELECT_PINS
        Dim CloseFinalStatePinsData As FTC_CLOSE_FINAL_STATE_PINS
        Dim WriteControlBuffer() As Byte = New Byte((WRITE_CONTROL_BUFFER_SIZE - 1)) {}
        Dim DataWord As Short = 0
        Dim bWriteWait As Boolean = True
        Dim NumDataBitsToWrite As Integer = 0
        Dim WriteDataBuffer() As Byte = New Byte((WRITE_DATA_BUFFER_SIZE - 1)) {}
        Dim NumDataBytesToWrite As Integer = 0
        Dim WriteDataBufferIndex As Integer = 0
        Dim WaitDataWriteComplete As FTC_WAIT_DATA_WRITE
        Dim ReadStartCondition As FTC_INIT_CONDITION
        Dim ReadDataBuffer() As Byte = New Byte((READ_DATA_BUFFER_SIZE - 1)) {}
        Dim NumDataBytesReturned As Integer
        Dim ReadCmdSequenceDataBuffer() As Byte = New Byte((READ_CMDS_DATA_BUFFER_SIZE - 1)) {}
        Dim ReadWordData() As Integer = New Integer((MAX_SPI_93LC56_CHIP_SIZE_IN_WORDS - 1)) {}
        Dim ReadWordValue As Integer
        Dim ReadDataIndex As Integer = 0
        Dim ReadDataWordAddress As Integer = 0
        Dim DataReadType As Integer = 0
        Dim NumDataBytesToRead As Long = 0
        Dim MsgBoxKeyPressed As Integer = 0
        Dim DataWordWritten As Short = 0
        Dim CharCntr As Integer = 0
        Dim iLoopCntr As Integer = 0
        Dim mismatchMsg As String
        Dim style As MsgBoxStyle = MsgBoxStyle.OkCancel
        Dim response As MsgBoxResult = MsgBoxResult.Ok

        Dim StatusErrorMessage As String = New String(ChrW(0), MAX_NUM_ERROR_MESSAGE_CHARS)
        Dim ErrorMessage As String

        Me.GPIOH0InputLowHighReadStateCheckBox.Checked = False
        Me.GPIOH1InputLowHighReadStateCheckBox.Checked = False
        Me.GPIOH2InputLowHighReadStateCheckBox.Checked = False
        Me.GPIOH3InputLowHighReadStateCheckBox.Checked = False
        Me.GPIOH4InputLowHighReadStateCheckBox.Checked = False
        Me.GPIOH5InputLowHighReadStateCheckBox.Checked = False
        Me.GPIOH6InputLowHighReadStateCheckBox.Checked = False
        Me.GPIOH7InputLowHighReadStateCheckBox.Checked = False

        Dim DllVersion As String = New String(ChrW(0), MAX_NUM_DLL_VERSION_CHARS)
        ftStatus = SPI_GetDllVersion(DllVersion, MAX_NUM_DLL_VERSION_CHARS)
        Me.DLLVersionLabel.Text = Dll_Version_Label + DllVersion
        Me.DLLVersionLabel.Refresh()
        'MsgBox(DllVersion)

        Me.DeviceNameLabel.Text = Device_Name_Label
        Me.DeviceNameLabel.Refresh()

        Me.FT2232HRadioButton.Checked = CheckState.Unchecked
        Me.FT4232HRadioButton.Checked = CheckState.Unchecked

        Me.PassFailResultsStatusLabel.Text = ""
        Me.PassFailureStatusStrip.Refresh()
        Sleep(1000)

        ftStatus = SPI_GetNumHiSpeedDevices(NumHiSpeedDevices)

        If ((ftStatus = FTC_SUCCESS) And (NumHiSpeedDevices > 0)) Then
            Do
                ftStatus = SPI_GetHiSpeedDeviceNameLocIDChannel(HiSpeedDeviceIndex, HiSpeedDeviceName, MAX_NUM_DEVICE_NAME_CHARS, LocationID, HiSpeedDeviceChannel, MAX_NUM_CHANNEL_CHARS, HiSpeedDeviceType)

                If (ftStatus = FTC_SUCCESS) Then
                    HSCH = New String(ConvertDLLStringToVBString(HiSpeedDeviceChannel))
                End If

                HiSpeedDeviceIndex = HiSpeedDeviceIndex + 1
            Loop While ((ftStatus = FTC_SUCCESS) And (HiSpeedDeviceIndex < NumHiSpeedDevices) And ((HSCH <> vbNullString) And (HSCH <> Me.ChannelComboBox.Text)))

            If (ftStatus = FTC_SUCCESS) Then
                If ((HSCH <> vbNullString) And (HSCH <> Me.ChannelComboBox.Text)) Then
                    ftStatus = FTC_DEVICE_IN_USE
                End If
            End If

            If (ftStatus = FTC_SUCCESS) Then
                HSDN = New String(ConvertDLLStringToVBString(HiSpeedDeviceName))
                ftStatus = SPI_OpenHiSpeedDevice(HSDN, LocationID, HSCH, ftHandle)

                Me.DeviceNameLabel.Text = Device_Name_Label + HSDN
                Me.DeviceNameLabel.Refresh()

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = SPI_GetHiSpeedDeviceType(ftHandle, HiSpeedDeviceType)

                    If (ftStatus = FTC_SUCCESS) Then
                        If (HiSpeedDeviceType = hiSpeedDeviceTypes.FT4232H_Device_Type) Then
                            Me.FT4232HRadioButton.Checked = CheckState.Checked 'True
                        ElseIf (HiSpeedDeviceType = hiSpeedDeviceTypes.FT2232H_Device_Type) Then
                            Me.FT2232HRadioButton.Checked = CheckState.Checked 'True
                        End If
                    End If
                End If
            End If

            If ((ftHandle <> 0) And (ftStatus = FTC_SUCCESS)) Then
                ftStatus = SPI_InitDevice(ftHandle, MAX_FREQ_93LC56_CLOCK_DIVISOR)

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = SPI_GetDeviceLatencyTimer(ftHandle, TimerValue)

                    If (ftStatus = FTC_SUCCESS) Then
                        ftStatus = SPI_SetDeviceLatencyTimer(ftHandle, 50)

                        If (ftStatus = FTC_SUCCESS) Then
                            ftStatus = SPI_GetDeviceLatencyTimer(ftHandle, TimerValue)

                            ftStatus = SPI_SetDeviceLatencyTimer(ftHandle, 16)

                            ftStatus = SPI_GetDeviceLatencyTimer(ftHandle, TimerValue)
                        End If
                    End If
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = TestHiSpeedDeviceClock(ftHandle)
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = SPI_SetLoopback(ftHandle, False)
                End If

                If ((ftStatus = FTC_SUCCESS) And (Me.CommandSequenceMenuItem.CheckState = CheckState.Checked)) Then
                    ftStatus = SPI_ClearDeviceCmdSequence(ftHandle)
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    ' Must set the chip select disable states for all the SPI devices connected to the FT2232C dual device
                    ChipSelectsDisableStates.bADBUS3ChipSelectPinState = False
                    ChipSelectsDisableStates.bADBUS4GPIOL1PinState = False
                    ChipSelectsDisableStates.bADBUS5GPIOL2PinState = False
                    ChipSelectsDisableStates.bADBUS6GPIOL3PinState = False
                    ChipSelectsDisableStates.bADBUS7GPIOL4PinState = False

                    If (HiSpeedDeviceType = hiSpeedDeviceTypes.FT2232H_Device_Type) Then
                        ' Set the 8 general purpose higher input/output pins
                        HighInputOutputPinsData.bPin1InputOutputState = Me.GPIOH0InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin2InputOutputState = Me.GPIOH1InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin3InputOutputState = Me.GPIOH2InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin4InputOutputState = Me.GPIOH3InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin5InputOutputState = Me.GPIOH4InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin6InputOutputState = Me.GPIOH5InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin7InputOutputState = Me.GPIOH6InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin8InputOutputState = Me.GPIOH7InputOutputInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin1LowHighState = Me.GPIOH0OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin2LowHighState = Me.GPIOH1OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin3LowHighState = Me.GPIOH2OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin4LowHighState = Me.GPIOH3OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin5LowHighState = Me.GPIOH4OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin6LowHighState = Me.GPIOH5OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin7LowHighState = Me.GPIOH6OutputLowHighInitialStateCheckBox.Checked
                        HighInputOutputPinsData.bPin8LowHighState = Me.GPIOH7OutputLowHighInitialStateCheckBox.Checked

                        ftStatus = SPI_SetHiSpeedDeviceGPIOs(ftHandle, ChipSelectsDisableStates, HighInputOutputPinsData)
                    Else
                        ftStatus = SPI_SetHiSpeedDeviceGPIOs(ftHandle, ChipSelectsDisableStates, HighInputOutputPinsData)
                    End If

                    If ((ftStatus = FTC_SUCCESS) And (HiSpeedDeviceType = hiSpeedDeviceTypes.FT2232H_Device_Type)) Then
                        Sleep(200)

                        ftStatus = SPI_GetHiSpeedDeviceGPIOs(ftHandle, HighPinsInputData)

                        If (ftStatus = FTC_SUCCESS) Then
                            If (Me.GPIOH0ReadUseNotUseStateCheckBox.Checked = True) Then
                                Me.GPIOH0InputLowHighReadStateCheckBox.Checked = HighPinsInputData.bPin1LowHighState
                            End If
                            If (Me.GPIOH1ReadUseNotUseStateCheckBox.Checked = True) Then
                                Me.GPIOH1InputLowHighReadStateCheckBox.Checked = HighPinsInputData.bPin2LowHighState
                            End If
                            If (Me.GPIOH2ReadUseNotUseStateCheckBox.Checked = True) Then
                                Me.GPIOH2InputLowHighReadStateCheckBox.Checked = HighPinsInputData.bPin3LowHighState
                            End If
                            If (Me.GPIOH3ReadUseNotUseStateCheckBox.Checked = True) Then
                                Me.GPIOH3InputLowHighReadStateCheckBox.Checked = HighPinsInputData.bPin4LowHighState
                            End If
                            If (Me.GPIOH4ReadUseNotUseStateCheckBox.Checked = True) Then
                                Me.GPIOH4InputLowHighReadStateCheckBox.Checked = HighPinsInputData.bPin5LowHighState
                            End If
                            If (Me.GPIOH5ReadUseNotUseStateCheckBox.Checked = True) Then
                                Me.GPIOH5InputLowHighReadStateCheckBox.Checked = HighPinsInputData.bPin6LowHighState
                            End If
                            If (Me.GPIOH6ReadUseNotUseStateCheckBox.Checked = True) Then
                                Me.GPIOH6InputLowHighReadStateCheckBox.Checked = HighPinsInputData.bPin7LowHighState
                            End If
                            If (Me.GPIOH7ReadUseNotUseStateCheckBox.Checked = True) Then
                                Me.GPIOH7InputLowHighReadStateCheckBox.Checked = HighPinsInputData.bPin8LowHighState
                            End If
                        End If
                    End If

                    Sleep(200)

                    If ((ftStatus = FTC_SUCCESS) And (Me.GPIOH0To7OnlyCheckBox.Checked = False)) Then
                        WriteStartCondition.bClockPinState = False
                        WriteStartCondition.bDataOutPinState = False
                        WriteStartCondition.bChipSelectPinState = False
                        WriteStartCondition.ChipSelectPin = ADBUS3ChipSelect

                        If (ftStatus = FTC_SUCCESS) Then
                            ' enable writing
                            ftStatus = SPI_EWEN_EWDS_ERAL_93LC56B_Device(ftHandle, WriteStartCondition, SPIEWENCmdIndex)

                            If (ftStatus = FTC_SUCCESS) Then
                                ' erase all
                                ftStatus = SPI_EWEN_EWDS_ERAL_93LC56B_Device(ftHandle, WriteStartCondition, SPIERALCmdIndex)

                                If (ftStatus = FTC_SUCCESS) Then
                                    ' disable writing
                                    ftStatus = SPI_EWEN_EWDS_ERAL_93LC56B_Device(ftHandle, WriteStartCondition, SPIEWDSCmdIndex)
                                End If
                            End If
                        End If
                    End If

                    Sleep(200)

                    If ((ftStatus = FTC_SUCCESS) And (Me.GPIOH0To7OnlyCheckBox.Checked = False)) Then
                        WaitDataWriteComplete.bWaitDataWriteComplete = True
                        WaitDataWriteComplete.WaitDataWritePin = ADBUS2DataIn
                        WaitDataWriteComplete.bDataWriteCompleteState = True
                        WaitDataWriteComplete.DataWriteTimeoutmSecs = 5000

                        HighPinsWriteActiveStates.bPin1State = Me.GPIOH0WriteUseNotUseStateCheckBox.Checked
                        HighPinsWriteActiveStates.bPin1ActiveState = Me.GPIOH0OutputLowHighWriteStateCheckBox.Checked
                        HighPinsWriteActiveStates.bPin2State = Me.GPIOH1WriteUseNotUseStateCheckBox.Checked
                        HighPinsWriteActiveStates.bPin2ActiveState = Me.GPIOH1OutputLowHighWriteStateCheckBox.Checked
                        HighPinsWriteActiveStates.bPin3State = Me.GPIOH2WriteUseNotUseStateCheckBox.Checked
                        HighPinsWriteActiveStates.bPin3ActiveState = Me.GPIOH2OutputLowHighWriteStateCheckBox.Checked
                        HighPinsWriteActiveStates.bPin4State = Me.GPIOH3WriteUseNotUseStateCheckBox.Checked
                        HighPinsWriteActiveStates.bPin4ActiveState = Me.GPIOH3OutputLowHighWriteStateCheckBox.Checked
                        HighPinsWriteActiveStates.bPin5State = Me.GPIOH4WriteUseNotUseStateCheckBox.Checked
                        HighPinsWriteActiveStates.bPin5ActiveState = Me.GPIOH4OutputLowHighWriteStateCheckBox.Checked
                        HighPinsWriteActiveStates.bPin6State = Me.GPIOH5WriteUseNotUseStateCheckBox.Checked
                        HighPinsWriteActiveStates.bPin6ActiveState = Me.GPIOH5OutputLowHighWriteStateCheckBox.Checked
                        HighPinsWriteActiveStates.bPin7State = Me.GPIOH6WriteUseNotUseStateCheckBox.Checked
                        HighPinsWriteActiveStates.bPin7ActiveState = Me.GPIOH6OutputLowHighWriteStateCheckBox.Checked
                        HighPinsWriteActiveStates.bPin8State = Me.GPIOH7WriteUseNotUseStateCheckBox.Checked
                        HighPinsWriteActiveStates.bPin8ActiveState = Me.GPIOH7OutputLowHighWriteStateCheckBox.Checked

                        DataWord = 0
                        'DataWord = 30583 '\x7777';

                        NumDataBitsToWrite = 16
                        NumDataBytesToWrite = 2

                        WriteDataWordAddress = 0

                        Do
                            ' set up write command and address
                            ControlLocAddress1 = &HA0
                            'ControlLocAddress1 = (ControlLocAddress1 Or ((WriteDataWordAddress >> 3) And &HF))
                            ControlLocAddress1 = (ControlLocAddress1 Or ((WriteDataWordAddress \ 8) And &HF))

                            ' shift left 5 bits ie make bottom 3 bits the 3 MSB's
                            ControlLocAddress2 = ((WriteDataWordAddress And &H7) * 32)

                            WriteControlBuffer(0) = (ControlLocAddress1 And &HFF)
                            WriteControlBuffer(1) = (ControlLocAddress2 And &HFF)

                            ' write data
                            WriteDataBuffer(0) = (DataWord And &HFF)
                            ' shift down by 8 bits
                            WriteDataBuffer(1) = ((DataWord >> 8) And &HFF)

                            ftStatus = SPI_WriteHiSpeedDevice(ftHandle, WriteStartCondition, True, False, 11, WriteControlBuffer, 2, bWriteWait, NumDataBitsToWrite, WriteDataBuffer, NumDataBytesToWrite, WaitDataWriteComplete, HighPinsWriteActiveStates)

                            If (DataWord <> 30583) Then
                                DataWord = DataWord + 1
                            End If

                            WriteDataWordAddress = WriteDataWordAddress + 1
                        Loop While ((WriteDataWordAddress < MAX_SPI_93LC56_CHIP_SIZE_IN_WORDS) And (ftStatus = FTC_SUCCESS))

                        Sleep(200)

                        If (ftStatus = FTC_SUCCESS) Then
                            If (ftStatus = FTC_SUCCESS) Then
                                Do
                                    Sleep(200)

                                    ReadStartCondition.bClockPinState = False
                                    ReadStartCondition.bDataOutPinState = False
                                    ReadStartCondition.bChipSelectPinState = False
                                    ReadStartCondition.ChipSelectPin = ADBUS3ChipSelect

                                    For ReadDataIndex = 0 To (MAX_SPI_93LC56_CHIP_SIZE_IN_WORDS - 1)
                                        ReadWordData(ReadDataIndex) = 0
                                    Next

                                    ReadDataWordAddress = 0

                                    Do
                                        ' set up read command and address
                                        ControlLocAddress1 = 192 '\xC0';
                                        'ControlLocAddress1 = (ControlLocAddress1 Or ((ReadDataWordAddress >> 3) And &HFF))
                                        ControlLocAddress1 = (ControlLocAddress1 Or ((ReadDataWordAddress \ 8) And &HFF))

                                        ' shift left 5 bits ie make bottom 3 bits the 3 MSB's
                                        ControlLocAddress2 = ((ReadDataWordAddress And &H7) * 32)

                                        WriteControlBuffer(0) = (ControlLocAddress1 And &HFF)
                                        WriteControlBuffer(1) = (ControlLocAddress2 And &HFF)

                                        If (Me.CommandSequenceMenuItem.CheckState = CheckState.Unchecked) Then
                                            HighPinsReadActiveStates.bPin1State = Me.GPIOH0ReadUseNotUseStateCheckBox.Checked
                                            HighPinsReadActiveStates.bPin2State = Me.GPIOH1ReadUseNotUseStateCheckBox.Checked
                                            HighPinsReadActiveStates.bPin3State = Me.GPIOH2ReadUseNotUseStateCheckBox.Checked
                                            HighPinsReadActiveStates.bPin4State = Me.GPIOH3ReadUseNotUseStateCheckBox.Checked
                                            HighPinsReadActiveStates.bPin5State = Me.GPIOH4ReadUseNotUseStateCheckBox.Checked
                                            HighPinsReadActiveStates.bPin6State = Me.GPIOH5ReadUseNotUseStateCheckBox.Checked
                                            HighPinsReadActiveStates.bPin7State = Me.GPIOH6ReadUseNotUseStateCheckBox.Checked
                                            HighPinsReadActiveStates.bPin8State = Me.GPIOH7ReadUseNotUseStateCheckBox.Checked

                                            ftStatus = SPI_ReadHiSpeedDevice(ftHandle, ReadStartCondition, True, False, NUM_93LC56B_CMD_CONTOL_BITS, WriteControlBuffer, NUM_93LC56B_CMD_CONTOL_BYTES, True, False, NUM_93LC56B_CMD_DATA_BITS, ReadDataBuffer, NumDataBytesReturned, HighPinsReadActiveStates)

                                            If (ftStatus = FTC_SUCCESS) Then
                                                If (HighPinsReadActiveStates.bPin1State = True) Then
                                                    Me.GPIOH0InputLowHighReadStateCheckBox.Checked = HighPinsReadActiveStates.bPin1ActiveState
                                                End If
                                                If (HighPinsReadActiveStates.bPin2State = True) Then
                                                    Me.GPIOH1InputLowHighReadStateCheckBox.Checked = HighPinsReadActiveStates.bPin2ActiveState
                                                End If
                                                If (HighPinsReadActiveStates.bPin3State = True) Then
                                                    Me.GPIOH2InputLowHighReadStateCheckBox.Checked = HighPinsReadActiveStates.bPin3ActiveState
                                                End If
                                                If (HighPinsReadActiveStates.bPin4State = True) Then
                                                    Me.GPIOH3InputLowHighReadStateCheckBox.Checked = HighPinsReadActiveStates.bPin4ActiveState
                                                End If
                                                If (HighPinsReadActiveStates.bPin5State = True) Then
                                                    Me.GPIOH4InputLowHighReadStateCheckBox.Checked = HighPinsReadActiveStates.bPin5ActiveState
                                                End If
                                                If (HighPinsReadActiveStates.bPin6State = True) Then
                                                    Me.GPIOH5InputLowHighReadStateCheckBox.Checked = HighPinsReadActiveStates.bPin6ActiveState
                                                End If
                                                If (HighPinsReadActiveStates.bPin7State = True) Then
                                                    Me.GPIOH6InputLowHighReadStateCheckBox.Checked = HighPinsReadActiveStates.bPin7ActiveState
                                                End If
                                                If (HighPinsReadActiveStates.bPin8State = True) Then
                                                    Me.GPIOH7InputLowHighReadStateCheckBox.Checked = HighPinsReadActiveStates.bPin8ActiveState
                                                End If

                                                ReadWordValue = ((ReadDataBuffer(1) * 256) Or ReadDataBuffer(0))

                                                ReadWordData(ReadDataWordAddress) = ReadWordValue
                                            End If
                                        Else
                                            ftStatus = SPI_AddHiSpeedDeviceReadCmd(ftHandle, ReadStartCondition, True, False, NUM_93LC56B_CMD_CONTOL_BITS, WriteControlBuffer, NUM_93LC56B_CMD_CONTOL_BYTES, True, False, NUM_93LC56B_CMD_DATA_BITS, HighPinsReadActiveStates)
                                        End If

                                        ReadDataWordAddress = ReadDataWordAddress + 1
                                    Loop While ((ReadDataWordAddress < MAX_SPI_93LC56_CHIP_SIZE_IN_WORDS) And (ftStatus = FTC_SUCCESS))

                                    If (ftStatus = FTC_SUCCESS) Then
                                        ReadDataIndex = 0

                                        If (Me.CommandSequenceMenuItem.CheckState = CheckState.Checked) Then
                                            ftStatus = SPI_ExecuteDeviceCmdSequence(ftHandle, ReadCmdSequenceDataBuffer, NumDataBytesReturned)

                                            If (ftStatus = FTC_SUCCESS) Then
                                                If (NumDataBytesReturned > 0) Then
                                                    ReadDataWordAddress = 0

                                                    ReadDataIndex = 0

                                                    Do
                                                        ReadWordValue = ((ReadCmdSequenceDataBuffer(ReadDataIndex + 1) * 256) Or ReadCmdSequenceDataBuffer(ReadDataIndex))

                                                        ReadWordData(ReadDataWordAddress) = ReadWordValue

                                                        ReadDataIndex = (ReadDataIndex + 2)

                                                        ReadDataWordAddress = ReadDataWordAddress + 1
                                                    Loop While (ReadDataIndex < NumDataBytesReturned)
                                                Else
                                                    response = MsgBox("No data returned.", style, "SPI Execute Command Sequence")
                                                End If
                                            End If
                                        End If

                                        If ((ftStatus = FTC_SUCCESS) And (response = MsgBoxResult.Ok)) Then
                                            ReadDataIndex = 0

                                            Do
                                                If (DataWord = 30583) Then
                                                    DataWordWritten = DataWord
                                                Else
                                                    DataWordWritten = ReadDataIndex
                                                End If

                                                If (((ReadWordData(ReadDataIndex) <> DataWordWritten) And (DataWord <> 0)) Or ((ReadWordData(ReadDataIndex) <> DataWordWritten) And (DataWord = 0))) Then
                                                    For CharCntr = 0 To (100 - 1)
                                                        WriteDataBuffer(CharCntr) = 0
                                                    Next

                                                    mismatchMsg = String.Format("SPI 93LC56 Read/Write mismatch, Address = {0}, Write Value = {1}, Read Value = {2}", ReadDataIndex, DataWordWritten, ReadWordData(ReadDataIndex))

                                                    response = MsgBox(mismatchMsg, style, "SPI Read Error Message")
                                                End If

                                                ReadDataIndex = ReadDataIndex + 1
                                            Loop While ((ReadDataIndex < MAX_SPI_93LC56_CHIP_SIZE_IN_WORDS) And (response = MsgBoxResult.Ok))
                                        End If
                                    End If

                                    iLoopCntr = iLoopCntr + 1
                                Loop While ((iLoopCntr < 10) And (ftStatus = FTC_SUCCESS) And (response = MsgBoxResult.Ok))
                            End If
                        End If
                    End If
                End If
            End If
        End If

        If (ftHandle <> 0) Then
            'CloseFinalStatePinsData.bTCKPinState = True
            'CloseFinalStatePinsData.bTCKPinActiveState = True
            'CloseFinalStatePinsData.bTDIPinState = True
            'CloseFinalStatePinsData.bTDIPinActiveState = False
            'CloseFinalStatePinsData.bTMSPinState = True
            'CloseFinalStatePinsData.bTMSPinActiveState = True

            'ftStatus = SPI_CloseDevice(ftHandle, CloseFinalStatePinsData)

            SPI_Close(ftHandle)
            ftHandle = 0
        End If

        If ((ftStatus <> FTC_SUCCESS) Or (NumHiSpeedDevices = 0) Or (mismatchMsg <> vbNullString)) Then
            If (ftStatus <> FTC_SUCCESS) Then
                ErrorMessage = "Status Code(" + ftStatus.ToString + ") - "

                ftStatus = SPI_GetErrorCodeString("EN", ftStatus, StatusErrorMessage, MAX_NUM_ERROR_MESSAGE_CHARS)

                ErrorMessage = ErrorMessage + New String(ConvertDLLStringToVBString(StatusErrorMessage))

                MsgBox(ErrorMessage)
            Else
                If (NumHiSpeedDevices = 0) Then
                    ErrorMessage = "There are no devices connected."

                    MsgBox(ErrorMessage)
                Else
                    ErrorMessage = mismatchMsg
                End If
            End If

            Me.PassFailResultsStatusLabel.Text = "Fail - " + ErrorMessage
            Me.PassFailureStatusStrip.Refresh()

            Console.WriteLine("Fail - " + ErrorMessage)
        Else
            Me.PassFailResultsStatusLabel.Text = "Pass"
            Me.PassFailureStatusStrip.Refresh()
        End If

        Beep()
    End Sub

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Text = App_Title

        Me.CommandSequenceMenuItem.CheckState = CheckState.Unchecked

        Me.ChannelComboBox.Items.Clear()
        Me.ChannelComboBox.Items.Add("A")
        Me.ChannelComboBox.Items.Add("B")
        Me.ChannelComboBox.Text = "A"
        'Me.ChannelComboBox.SelectedIndex = -1
    End Sub

    Private Sub MainForm_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        Dim ftStatus As Integer = FTC_SUCCESS

        If (ftHandle <> 0) Then
            ftStatus = SPI_Close(ftHandle)

            ftHandle = 0
        End If
    End Sub

    Private Sub ExitMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitMenuItem.Click
        Me.Close()
    End Sub

    Private Sub CommandSequenceMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandSequenceMenuItem.Click
        If (Me.CommandSequenceMenuItem.CheckState = CheckState.Unchecked) Then
            Me.CommandSequenceMenuItem.CheckState = CheckState.Checked
        Else
            Me.CommandSequenceMenuItem.CheckState = CheckState.Unchecked
        End If
    End Sub

    Private Sub GPIOH0InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH0InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOH0InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOH0OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOH0OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOH0OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH1InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH1InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOH1InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOH1OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOH1OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOH1OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH2InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH2InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOH2InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOH2OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOH2OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOH2OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH3InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH3InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOH3InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOH3OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOH3OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOH3OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH4InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH4InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOH4InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOH4OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOH4OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOH4OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH5InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH5InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOH5InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOH5OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOH5OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOH5OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH6InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH6InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOH6InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOH6OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOH6OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOH6OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH7InputOutputInitialStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH7InputOutputInitialStateCheckBox.CheckedChanged
        If (Me.GPIOH7InputOutputInitialStateCheckBox.Checked = False) Then
            Me.GPIOH7OutputLowHighInitialStateCheckBox.Enabled = False
        Else
            Me.GPIOH7OutputLowHighInitialStateCheckBox.Enabled = True
        End If

        Me.GPIOH7OutputLowHighInitialStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH0WriteUseNotUseStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH0WriteUseNotUseStateCheckBox.CheckedChanged
        If (Me.GPIOH0WriteUseNotUseStateCheckBox.Checked = False) Then
            Me.GPIOH0OutputLowHighWriteStateCheckBox.Enabled = False
        Else
            Me.GPIOH0OutputLowHighWriteStateCheckBox.Enabled = True
        End If

        Me.GPIOH0OutputLowHighWriteStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH1WriteUseNotUseStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH1WriteUseNotUseStateCheckBox.CheckedChanged
        If (Me.GPIOH1WriteUseNotUseStateCheckBox.Checked = False) Then
            Me.GPIOH1OutputLowHighWriteStateCheckBox.Enabled = False
        Else
            Me.GPIOH1OutputLowHighWriteStateCheckBox.Enabled = True
        End If

        Me.GPIOH1OutputLowHighWriteStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH2WriteUseNotUseStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH2WriteUseNotUseStateCheckBox.CheckedChanged
        If (Me.GPIOH2WriteUseNotUseStateCheckBox.Checked = False) Then
            Me.GPIOH2OutputLowHighWriteStateCheckBox.Enabled = False
        Else
            Me.GPIOH2OutputLowHighWriteStateCheckBox.Enabled = True
        End If

        Me.GPIOH2OutputLowHighWriteStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH3WriteUseNotUseStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH3WriteUseNotUseStateCheckBox.CheckedChanged
        If (Me.GPIOH3WriteUseNotUseStateCheckBox.Checked = False) Then
            Me.GPIOH3OutputLowHighWriteStateCheckBox.Enabled = False
        Else
            Me.GPIOH3OutputLowHighWriteStateCheckBox.Enabled = True
        End If

        Me.GPIOH3OutputLowHighWriteStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH4WriteUseNotUseStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH4WriteUseNotUseStateCheckBox.CheckedChanged
        If (Me.GPIOH4WriteUseNotUseStateCheckBox.Checked = False) Then
            Me.GPIOH4OutputLowHighWriteStateCheckBox.Enabled = False
        Else
            Me.GPIOH4OutputLowHighWriteStateCheckBox.Enabled = True
        End If

        Me.GPIOH4OutputLowHighWriteStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH5WriteUseNotUseStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH5WriteUseNotUseStateCheckBox.CheckedChanged
        If (Me.GPIOH5WriteUseNotUseStateCheckBox.Checked = False) Then
            Me.GPIOH5OutputLowHighWriteStateCheckBox.Enabled = False
        Else
            Me.GPIOH5OutputLowHighWriteStateCheckBox.Enabled = True
        End If

        Me.GPIOH5OutputLowHighWriteStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH6WriteUseNotUseStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH6WriteUseNotUseStateCheckBox.CheckedChanged
        If (Me.GPIOH6WriteUseNotUseStateCheckBox.Checked = False) Then
            Me.GPIOH6OutputLowHighWriteStateCheckBox.Enabled = False
        Else
            Me.GPIOH6OutputLowHighWriteStateCheckBox.Enabled = True
        End If

        Me.GPIOH6OutputLowHighWriteStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH7WriteUseNotUseStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH7WriteUseNotUseStateCheckBox.CheckedChanged
        If (Me.GPIOH7WriteUseNotUseStateCheckBox.Checked = False) Then
            Me.GPIOH7OutputLowHighWriteStateCheckBox.Enabled = False
        Else
            Me.GPIOH7OutputLowHighWriteStateCheckBox.Enabled = True
        End If

        Me.GPIOH7OutputLowHighWriteStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH0ReadUseNotUseStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH0ReadUseNotUseStateCheckBox.CheckedChanged
        If (Me.GPIOH0ReadUseNotUseStateCheckBox.Checked = False) Then
            Me.GPIOH0InputLowHighReadStateCheckBox.Enabled = False
        Else
            Me.GPIOH0InputLowHighReadStateCheckBox.Enabled = True
        End If

        Me.GPIOH0InputLowHighReadStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH1ReadUseNotUseStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH1ReadUseNotUseStateCheckBox.CheckedChanged
        If (Me.GPIOH1ReadUseNotUseStateCheckBox.Checked = False) Then
            Me.GPIOH1InputLowHighReadStateCheckBox.Enabled = False
        Else
            Me.GPIOH1InputLowHighReadStateCheckBox.Enabled = True
        End If

        Me.GPIOH1InputLowHighReadStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH2ReadUseNotUseStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH2ReadUseNotUseStateCheckBox.CheckedChanged
        If (Me.GPIOH2ReadUseNotUseStateCheckBox.Checked = False) Then
            Me.GPIOH2InputLowHighReadStateCheckBox.Enabled = False
        Else
            Me.GPIOH2InputLowHighReadStateCheckBox.Enabled = True
        End If

        Me.GPIOH2InputLowHighReadStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH3ReadUseNotUseStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH3ReadUseNotUseStateCheckBox.CheckedChanged
        If (Me.GPIOH3ReadUseNotUseStateCheckBox.Checked = False) Then
            Me.GPIOH3InputLowHighReadStateCheckBox.Enabled = False
        Else
            Me.GPIOH3InputLowHighReadStateCheckBox.Enabled = True
        End If

        Me.GPIOH3InputLowHighReadStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH4ReadUseNotUseStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH4ReadUseNotUseStateCheckBox.CheckedChanged
        If (Me.GPIOH4ReadUseNotUseStateCheckBox.Checked = False) Then
            Me.GPIOH4InputLowHighReadStateCheckBox.Enabled = False
        Else
            Me.GPIOH4InputLowHighReadStateCheckBox.Enabled = True
        End If

        Me.GPIOH4InputLowHighReadStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH5ReadUseNotUseStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH5ReadUseNotUseStateCheckBox.CheckedChanged
        If (Me.GPIOH5ReadUseNotUseStateCheckBox.Checked = False) Then
            Me.GPIOH5InputLowHighReadStateCheckBox.Enabled = False
        Else
            Me.GPIOH5InputLowHighReadStateCheckBox.Enabled = True
        End If

        Me.GPIOH5InputLowHighReadStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH6ReadUseNotUseStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH6ReadUseNotUseStateCheckBox.CheckedChanged
        If (Me.GPIOH6ReadUseNotUseStateCheckBox.Checked = False) Then
            Me.GPIOH6InputLowHighReadStateCheckBox.Enabled = False
        Else
            Me.GPIOH6InputLowHighReadStateCheckBox.Enabled = True
        End If

        Me.GPIOH6InputLowHighReadStateCheckBox.Checked = False
    End Sub

    Private Sub GPIOH7ReadUseNotUseStateCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GPIOH7ReadUseNotUseStateCheckBox.CheckedChanged
        If (Me.GPIOH7ReadUseNotUseStateCheckBox.Checked = False) Then
            Me.GPIOH7InputLowHighReadStateCheckBox.Enabled = False
        Else
            Me.GPIOH7InputLowHighReadStateCheckBox.Enabled = True
        End If

        Me.GPIOH7InputLowHighReadStateCheckBox.Checked = False
    End Sub
End Class
